'From Smalltalk/X, Version:2.7.1 on 5-Aug-1993 at 21:11:22'!

StandardSystemView subclass:#Example1
         instanceVariableNames:'subview subButton autoJump sizeSlider speedSlider contBlock'
         classVariableNames:''
         poolDictionaries:''
         category:'Demos-Tutorial'
!

Example1 comment:'

Tutorial example - a view with a subview;

    Example1 start


%W% %E%
written spring 92 by claus
'!

!Example1 methodsFor:'actions'!

realize

self sizeChanged:nil.

super realize.
!

destroy

    super destroy.

    Processor removeTimedBlock:contBlock.
!

abortAutoJump
    "comment stating purpose of message"

    contBlock isNil ifFalse: [
        Processor removeTimedBlock:contBlock.
        subButton pressAction:contBlock.
   ]
!

speedSliderChanged
    "comment stating purpose of message"

    contBlock isNil ifFalse: [
        Processor removeTimedBlock:contBlock.
        Processor addTimedBlock:contBlock after: speedSlider thumbOrigin // 10.
   ]
!

moveToLeftUpperCorner
    "comment stating purpose of message"

    subButton origin:[0 @ 0].
    self moveTo:#moveToRightUpperCorner
!

moveTo:where
    "comment stating purpose of message"

    autoJump ifTrue:[
        contBlock := [self perform:where].
        subButton pressAction:[self abortAutoJump].
        Processor addTimedBlock:contBlock after: ((speedSlider thumbOrigin // 10) max:0.1).
    ] ifFalse: [
        subButton pressAction:[self perform:where].
    ]
!

centerButton
    "comment stating purpose of message"

    subButton origin:[(subview width - subButton width // 2)
                        @ 
                        (subview height - subButton height // 2)].

    self moveTo:#moveToLeftUpperCorner
!

moveToRightUpperCorner
    "comment stating purpose of message"

    subButton origin:[(subview width - subButton width) @ 0].
    self moveTo:#moveToRightLowerCorner
!

moveToLeftLowerCorner
    "comment stating purpose of message"


    subButton origin:[ 0 @ (subview height - subButton height) ].
    self moveTo:#centerButton
!

moveToRightLowerCorner
    "comment stating purpose of message"

    subButton origin:[ (subview width - subButton width)
                         @ 
                       (subview height - subButton height) ].

    self moveTo:#moveToLeftLowerCorner
!

maximizeButton
    "comment stating purpose of message"

    subButton origin:[((subview width // 2) - (subview width // 4))
                        @ 
                        ((subview height // 2) - (subview height // 4))]
                 extent:[(subview width // 2)
                          @ 
                          ( subview height // 2)]
!

minimizeButton
    "comment stating purpose of message"


    subButton origin:[((subview width // 2) - (subview width // 8))
                        @ 
                        ((subview height // 2) - (subview height // 8))]
                 extent:[(subview width // 4)
                          @ 
                          ( subview height // 4)]
! !

!Example1 methodsFor:'initialization'!

initialize
    |hPixelPerMM vPixelPerMM sliderView labelView speedLabel sizeLabel|

    super initialize.

    self label:'Turorial Example1'.

    hPixelPerMM := self horizontalPixelPerMillimeter rounded asInteger.
    vPixelPerMM := self verticalPixelPerMillimeter rounded asInteger.

"................."

    labelView := View origin:[hPixelPerMM @ vPixelPerMM]
                       extent:[(hPixelPerMM * 30)
                                @ 
                               ((vPixelPerMM * 3) + (vPixelPerMM * 10))
                              ]
                            in:self.

    labelView level:0.
    labelView borderWidth:0.

"................."

    speedLabel := Label origin:[hPixelPerMM @ vPixelPerMM]
                            in:labelView.

    speedLabel label:'speed :  5 sec.'.
    speedLabel borderWidth:1.
    speedLabel sizeFixed:true; adjust:#left.

    sizeLabel := Label origin:[hPixelPerMM @ ((vPixelPerMM * 2) + (vPixelPerMM * 5))]
                           in:labelView.

    sizeLabel label:'size  : 25 %   '. 
    sizeLabel borderWidth:1.
    sizeLabel sizeFixed:true; adjust:#left.

"................."

    sliderView := View origin:[(hPixelPerMM + labelView width) @ vPixelPerMM]
                       extent:[(width - (hPixelPerMM * 2) - labelView width)
                                @ 
                               ((vPixelPerMM * 3) + (vPixelPerMM * 10))
                              ]
                            in:self.

    sliderView level:0.
    sliderView borderWidth:0.

"................."

    speedSlider := HorizontalSlider in:sliderView.

    speedSlider origin:(hPixelPerMM @ vPixelPerMM)
                extent:[(sliderView width - (hPixelPerMM * 2)) @ (vPixelPerMM * 5)].

    speedSlider thumbOrigin:50.

    speedSlider scrollAction:[:percent | speedLabel label:'speed : ',
                                                          ((percent // 10) rounded printStringRightAdjustLen:2),
                                                          ' sec.'.
                               self speedSliderChanged].

"................."

    sizeSlider  := HorizontalSlider in:sliderView.

    sizeSlider origin:[hPixelPerMM @ (speedSlider bottom + vPixelPerMM)]
               extent:[(sliderView width - (hPixelPerMM * 2)) @ (vPixelPerMM * 5)].

    sizeSlider thumbOrigin:50.

    sizeSlider scrollAction:[:percent | sizeLabel label:'size  : ',
                                                        ((percent // 2) rounded printStringRightAdjustLen:2),
                                                        ' %'.
                              subButton superViewChangedSize].

"................."

    subview := View origin:[hPixelPerMM @ (sliderView bottom + vPixelPerMM)]
                    extent:[(width - (hPixelPerMM * 2))
                             @ 
                            (height - (2 * (vPixelPerMM * 2)) - (sliderView height))
                           ]
                        in:self.

    subview level:-1.

"................."

    subButton := Button origin:[((subview width // 2) - ((subview width / 400 * sizeSlider thumbOrigin) rounded))
                                 @ 
                                ((subview height // 2) - ((subview height / 400 * sizeSlider thumbOrigin) rounded))
                               ]
                        extent:[(subview width / 200 * sizeSlider thumbOrigin) rounded
                                 @ 
                                (subview height / 200 * sizeSlider thumbOrigin) rounded
                               ]
                            in:subview.

    autoJump := true.

    subButton pressAction:[self moveToLeftUpperCorner].

"
    subButton pressAction:[self maximizeButton]
    subButton releaseAction:[self minimizeButton].
"

    "Example1 start"
! !
