"
 COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#CommanderDemo
       instanceVariableNames:'drawView'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

CommanderDemo comment:'
 play around with a commander

 start with:
       CommanderDemo start

 %W% %E%
 written spring 89 by claus
'!

!CommanderDemo class methodsFor:'standalone startup'!

start
    self new start

    "CommanderDemo start"
! !

!CommanderDemo methodsFor:'startup'!

start
    |topView panel fastToggle slowToggle|

    topView := StandardSystemView
                    label:'CommanderDemo'
                    icon:(Form fromFile:'CommanderDemo.icon').

    topView minExtent:(600 @ 400).

    panel := PanelView origin:(0.0 @ 0.0) extent:(1.0 @ 1.0) in:topView.

    drawView := panel.

    Button label:'spiral 121'
          action:[self spiral:121]
              in:panel.

    Button label:'spiral 89'
          action:[self spiral:89]
              in:panel.

    Button label:'spiral 59'
          action:[self spiral:59]
              in:panel.

    Button label:'mandala'
          action:[self mandala]
              in:panel.

    slowToggle :=
        Toggle label:'slow'
              action:[fastToggle turnOff. topView device unBuffered]
                  in:panel.

    fastToggle :=
        Toggle label:'fast'
              action:[slowToggle turnOff. topView device buffered]
                  in:panel.
    fastToggle turnOn.

    Button label:'quit'
          action:[topView destroy]
              in:panel.

    topView open.
! !

!CommanderDemo methodsFor:'user interaction'!

spiral:angle
    |bic|
    drawView clear.
    bic := Commander new:4 in:drawView.
    bic fanOut.
    bic do:[:eachPen | eachPen up. eachPen go:100. eachPen down].
    bic do:[:eachPen | eachPen spiral:200 angle:angle]
!

mandala
    |bic|
    drawView clear.
    bic := Commander new:4 in:drawView.
    bic fanOut.
    bic do:[:eachPen | eachPen up. eachPen go:100. eachPen down].
    bic do:[:eachPen | eachPen mandala:10 radius:100]
! !
