'From Smalltalk/X, Version:2.4.2 on 11-Okt-1992 at 20:52:28'!

Controller subclass:#ColorDrawDemo
         instanceVariableNames:'topView drawView topPanel buttonPanel1 buttonPanel2 lastPoint
                                currentColor currentLineWidth'
         classVariableNames:''
         poolDictionaries:''
         category:'Demos-Graphics'
!

ColorDrawDemo comment:'
This demo was inspired by a similar demonstration program from
a motif manual.

 start with:
       ColorDrawDemo start

'!

!ColorDrawDemo class methodsFor:'startup'!

start
    self new start

    "ColorDrawDemo start"
! !

!ColorDrawDemo methodsFor:'startup'!

start
    self setupViews.
    topView open.
!

setupViews
    |quitButton v clearButton group|

    topView := StandardSystemView new.
    topView label:'ColorDrawDemo'.

    topPanel := View origin:(0.0 @ 0.0) extent:(1.0 @ 0.9) in:topView.
    topPanel borderWidth:0.

    buttonPanel1 := PanelView
                        origin:(0.0 @ 0.0) extent:(0.2 @ 0.7) in:topPanel.
    buttonPanel1 borderWidth:0.

    buttonPanel2 := PanelView
                        origin:(0.0 @ 0.9) extent:(1.0 @ 0.1) in:topView.

    drawView := View origin:0.21 @ 0.01 corner:0.99 @ 1.0 in:topPanel.
    drawView viewBackground:(Color white).
    drawView enableButtonEvents.
    drawView enableButtonMotionEvents.
    "catch its events ..."
    drawView delegate:self.
    drawView level:-1.

    buttonPanel1 space:8.
    buttonPanel1 layout:#spread.

    group := RadioButtonGroup new.

    #('Black' 'Red' 'Green' 'Blue' 'White' 'Navy' 'Orange'
      'Yellow' 'Pink' 'Magenta' 'Cyan' 'Brown' 'Grey' 
    ) do:[:colorName |
        group add:(self addColorButtonFor:colorName to:buttonPanel1)
    ].

    quitButton := Button label:'quit' 
                        action:[topView destroy]
                            in:buttonPanel2.

    clearButton := Button label:'clear' 
                         action:[drawView clear]
                             in:buttonPanel2.
    ^ self
!

addColorButtonFor:colorName to:aPanel
    |butt form sz thisColor|

    sz := (aPanel horizontalPixelPerMillimeter:8) truncated.
    butt := RadioButton in:aPanel.
    butt showLamp:false.
    form := Form width:sz height:sz depth:(aPanel device depth).
    thisColor := (Color name:colorName).
    form paint:thisColor.
    form fillRectangleX:0 y:0 width:sz height:sz.
    butt form:form.
    butt offLevel:2; onLevel:-2.
    butt extent:((sz + 8) @ (sz + 8)).
    butt action:[currentColor := thisColor. drawView paint:thisColor].
    ^ butt
! !

!ColorDrawDemo methodsFor:'drawView events'!

buttonPress:button x:x y:y view:aView
    lastPoint := x @ y.
    drawView paint:currentColor.
    drawView displayLineFromX:x y:y toX:x y:y
!

buttonRelease:button x:x y:y view:aView
    ^ self
!

buttonMotion:state x:x y:y view:aView
    lastPoint notNil ifTrue:[
        drawView paint:currentColor.
        drawView displayLineFromX:lastPoint x y:lastPoint y
                              toX:x y:y
    ].
    lastPoint := x @ y
! !
