StandardSystemView subclass:#ColorScaleDemo
       instanceVariableNames:'nGrey reds greens blues greys'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

ColorScaleDemo comment:'
 demonstrates use of colors - notice that the window looks good
 on monochrome and limited greyscale displays (colors will
 be automatically dithered).

 (actually this is one of my test programs for color handling)

 start with:
        ColorScaleDemo start

 %W% %E%
 written summer 92 by claus
'!

!ColorScaleDemo class methodsFor:'startup'!

start
    self start:13
!

start:nGrey
    |aDemo|

    aDemo := self 
                label:'ColorScales'
                icon:(Form fromFile:'ColorScales.xbm' resolution:100)
                minExtent:(300 @ 200)
                maxExtent:(1000 @ 200).

    aDemo extent:(Display width // 2 @ 200).
    aDemo nGrey:nGrey.
    aDemo font:(Font family:'helvetica'
                       face:'bold' 
                      style:'roman'
                       size:14).
    aDemo open.
    ^ aDemo

    "ColorScaleDemo start:13"
    "MessageTally spyOn:[
ColorScaleDemo start:256]"
! !

!ColorScaleDemo methodsFor:'accessing'!

nGrey:aNumber
    |delta percent|

    nGrey := aNumber.

    reds := Array new:nGrey.
    greens := Array new:nGrey.
    blues := Array new:nGrey.
    greys := Array new:nGrey.
    delta := (100 / (nGrey - 1)) asFloat.
    percent := 0.0.
    1 to:nGrey do:[:index |
        reds at:index put:((Color red:percent green:0 blue:0) on:device).
        greens at:index put:((Color red:0 green:percent blue:0) on:device).
        blues at:index put:((Color red:0 green:0 blue:percent) on:device).
        greys at:index put:((Color grey:percent) on:device).
        percent := percent + delta
    ]
!

redraw
    "pretty easy; mostly complicated by rounding so that cutoff does
     not accumulate"

    |x xRounded y yRounded w wRounded h hRounded delta percent string p|

    delta := 100 / (nGrey - 1).
    x := 0.0.
    percent := 0.
    w := width / nGrey.
    h := height / 4.
    1 to:nGrey do:[:index |
        y := 0.0.
        xRounded := x rounded asInteger.
        wRounded := (x + w) rounded asInteger - x rounded asInteger.
        yRounded := y rounded asInteger.
        hRounded := (y + h) rounded asInteger - y rounded asInteger.
        self paint:(reds at:index).
        self fillRectangleX:xRounded y:yRounded width:wRounded height:hRounded.

        y := y + h.
        yRounded := y rounded asInteger.
        hRounded := (y + h) rounded asInteger - y rounded asInteger.
        self paint:(greens at:index).
        self fillRectangleX:xRounded y:yRounded width:wRounded height:hRounded.

        y := y + h.
        yRounded := y rounded asInteger.
        hRounded := (y + h) rounded asInteger - y rounded asInteger.
        self paint:(blues at:index).
        self fillRectangleX:xRounded y:yRounded width:wRounded height:hRounded.

        y := y + h.
        yRounded := y rounded asInteger.
        hRounded := (y + h) rounded asInteger - y rounded asInteger.
        self paint:(greys at:index).
        self fillRectangleX:xRounded y:yRounded width:wRounded height:hRounded.

        p := percent rounded asInteger.
        string := p printString , '%'.

        (font widthOf:string) + 5 > wRounded ifTrue:[
            string := p printString
        ].
        (font widthOf:string) + 5 > wRounded ifFalse:[
            (p > 60) ifTrue:[
                self paint:Black
            ] ifFalse:[
                self paint:White
            ].

            self displayString:string x:(xRounded + 5) y:20.
            self paint:Black.
            self displayRectangleX:xRounded y:0 width:wRounded height:height
        ].
        percent := (percent + delta).
        x := x + w
    ].
    self paint:White.
    self displayString:'red'   x:5 y:(20 + font ascent).
    self displayString:'green' x:5 y:(20 + (height // 4) + font ascent).
    self displayString:'blue'  x:5 y:(20 + (height // 4 * 2) + font ascent).
    self displayString:'grey'  x:5 y:(20 + (height // 4 * 3) + font ascent)

! !
