StandardSystemView subclass:#Example6
       instanceVariableNames:'subview1 textview'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Tutorial'
!

Example6 comment:'

Tutorial example - a view with 2 subviews
size ratios are variable; 2nd view is a text view showing some text;
the textview is scrollable

    Example6 start

%W% %E%
written spring 92 by claus
'!

!Example6 methodsFor:'initialization'!

initialize
    |hPixelPerMM vPixelPerMM helpview|

    super initialize.

    self label:'Turorial Example6'.

    hPixelPerMM := self horizontalPixelPerMillimeter rounded asInteger.
    vPixelPerMM := self verticalPixelPerMillimeter rounded asInteger.

    helpview := VariableVerticalPanel origin:(hPixelPerMM @ vPixelPerMM)
                                      extent:[(width - (hPixelPerMM * 2))
                                              @ 
                                              (height - (vPixelPerMM * 2))]
                                          in:self.

    subview1 := View origin:(0.0 @ 0.0)
                     corner:(1.0 @ 0.5)
                         in:helpview.
    subview1 level:-1.

    textview := ScrollableView for:TextView in:helpview.
    textview origin:(0.0 @ 0.5)
             corner:(1.0 @ 1.0).

    textview contents:'
This is a scrollable TextView

You can scroll the contents of this view using the scrollbar on
the left; the two buttons scroll one line up/down;

The thumb allows you to position anywhere in the text - press the
mouse on the thumb and move while keeping the mouse-button pressed.

The size of the thumb shows how much of the full text is visible in
the TextView - try resizing the view and see how the thumb changes
its size.

Notice, that this view has a popup-menu (right button)
and it supports copy.

Bbecause its not an EditTextView, it does not support cut & paste.

see next example(s) for more ...
'

    "Example6 start"
! !
