StandardSystemView subclass:#Example7
       instanceVariableNames:'subview1 textview'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Tutorial'
!

Example7 comment:'

Tutorial example - a view with 2 subviews
size ratios are variable; 2nd view is a text view showing /etc/passwd;
the textview is scrollable

    Example7 start

%W% %E%
written spring 92 by claus
'!

!Example7 methodsFor:'initialization'!

initialize
    |hPixelPerMM vPixelPerMM helpview|

    super initialize.

    self label:'Turorial Example7'.

    hPixelPerMM := self horizontalPixelPerMillimeter rounded asInteger.
    vPixelPerMM := self verticalPixelPerMillimeter rounded asInteger.

    helpview := VariableVerticalPanel origin:(hPixelPerMM @ vPixelPerMM)
                                      extent:[(width - (hPixelPerMM * 2))
                                              @ 
                                              (height - (vPixelPerMM * 2))]
                                          in:self.

    subview1 := TextView origin:(0.0 @ 0.0)
                         corner:(1.0 @ 0.3)
                             in:helpview.
    subview1 level:-1.
    subview1 contents:'
Below you see the contents of the file:''/etc/passwd''
(which I have choosen because its known to exist on every system).

You cannot edit this file - its just displayed for this demo.
'.

    textview := ScrollableView for:TextView in:helpview.
    textview origin:(0.0 @ 0.3)
             corner:(1.0 @ 1.0).

    textview contents:(FileStream readonlyFileNamed:'/etc/passwd') contents

    "Example7 start"
! !
