StandardSystemView subclass:#Example9
         instanceVariableNames:'menu myView'
         classVariableNames:''
         poolDictionaries:''
         category:'Demos-Tutorial'
!

Example9 comment:'

Tutorial example - a complete setup for a scrollable view with a menu.

    Example9 start

%W% %E%
written spring 92 by claus
'!

!Example9 methodsFor:'initialize / release'!

initialize
    "setup view"

    |menu scrollingView|

    super initialize.

    self label:'Tutorial Example 9'.

    menu := PullDownMenu in:self.
    menu labels:#('file' 'edit').

    menu at:'file'
            putLabels:#('new' 
                        'open ..' 
                        '-' 
                        'save' 
                        'save as' 
                        '-' 
                        'print'
                        '-' 
                        'quit')
            selectors:#(doNew doOpen nil 
                        doSave doSaveAs nil doPrint
                        nil destroy)
             receiver:self.

    menu at:'edit'
            putLabels:#('copy' 
                        'cut' 
                        'paste')
            selectors:#(copySelection cutSelection pasteBuffer)
             receiver:self.

    scrollingView := HVScrollableView for:View in:self.
    scrollingView origin:(0 @ menu height)
                  extent:[width @ (height - menu height)].
    myView := scrollingView scrolledView

   "Example9 start"

! !

!Example9 methodsFor:'user interaction'!

doNew
    Transcript showCr:'new'
!

doOpen
    Transcript showCr:'open'
!

doSave
    Transcript showCr:'save'
!

doSaveAs
    Transcript showCr:'save as'
!

doPrint
    Transcript showCr:'print'
!

copySelection
    Transcript showCr:'copy'
!

cutSelection
    Transcript showCr:'cut'
!

pasteBuffer
    Transcript showCr:'paste'
! !
