View subclass:#FormDrawView
         instanceVariableNames:'canvas'
         classVariableNames:''
         poolDictionaries:''
         category:'Demos-Graphics'
!

FormDrawView comment:'
I realize a view which does drawing onto both the screen
and a backing canvas, from this canvas we redraw (there is also
a possibility to add printing etc)
'!

!FormDrawView methodsFor:'initialization'!

initialize
    super initialize.
    canvas := Form width:1024
                  height:768
                   depth:(Display depth).
    canvas paint:(Color white).
    canvas fillRectangleX:0 y:0 width:(canvas width)
                               height:(canvas height)
! !

!FormDrawView methodsFor:'queries'!

widthOfContents
    ^ canvas width
!

heightOfContents
    ^ canvas height
! !

!FormDrawView methodsFor:'events'!

redraw
    self foreground:(Color colorId:1) background:(Color colorId:1).
    self foreground:(Color white) background:(Color white).
    self function:#copy.
    self displayOpaqueForm:canvas x:(0 - viewOrigin x) y:(0 - viewOrigin y)
! !

!FormDrawView methodsFor:'graphic access'!

paint:aColor
    canvas paint:aColor.
    super paint:aColor
!

capStyle:aStyle
    canvas capStyle:aStyle.
    super capStyle:aStyle
!

lineWidth:aNumber
    canvas lineWidth:aNumber.
    super lineWidth:aNumber
! !

!FormDrawView methodsFor:'drawing'!

clear
    canvas paint:(Color white).
    canvas fillRectangleX:0 y:0 width:(canvas width)
                               height:(canvas height).
    super clear
!

displayLineFromX:x1 y:y1 toX:x2 y:y2
    canvas displayLineFromX:x1 + viewOrigin x
                          y:y1 + viewOrigin y
                        toX:x2 + viewOrigin x
                          y:y2 + viewOrigin y.
    super displayLineFromX:x1 y:y1 toX:x2 y:y2
! !
