StandardSystemView subclass:#GreyScaleDemo
       instanceVariableNames:'nGrey colors'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

GreyScaleDemo comment:'
 demonstrates use of colors - notice that the window looks good
 on monochrome and limited greyscale displays (colors will
 be automatically dithered).

 (actually this is one of my test programs for color handling)

 start with:

        GreyScaleDemo start

 %W% %E%
 written summer 92 by claus
'!

!GreyScaleDemo class methodsFor:'startup'!

start
    self start:13
!

start:nGrey
    |aDemo|

    aDemo := self 
                label:'GreyScales'
                icon:(Form fromFile:'GreyScales.xbm' resolution:100)
                minExtent:(300 @ 50)
                maxExtent:(1000 @ 50).

    aDemo extent:(Display width // 2 @ 50).
    aDemo nGrey:nGrey.
    aDemo font:(Font family:'helvetica'
                       face:'bold' 
                      style:'roman'
                       size:14).
    aDemo open.
    ^ aDemo

    "GreyScaleDemo start:13"
    "GreyScaleDemo start:26"
    "GreyScaleDemo start:100"
    "GreyScaleDemo start:200"
! !

!GreyScaleDemo methodsFor:'accessing'!

nGrey:aNumber
    |delta percent|

    nGrey := aNumber.

    colors := Array new:nGrey.
    delta := 100 / (nGrey - 1).
    percent := 0.
    1 to:nGrey do:[:index |
        colors at:index put:(Color grey:percent).
        percent := percent + delta
    ]
!

redraw
    "pretty easy; mostly complicated by rounding so that cutoff does
     not accumulate"

    |x xRounded w wRounded delta percent string|

    shown ifFalse:[^ self].

    delta := 100 / (nGrey - 1).
    x := 0.0.
    percent := 0.
    w := width / nGrey.
    1 to:nGrey do:[:index |
        xRounded := x rounded asInteger.
        wRounded := (x + w) rounded asInteger - x rounded asInteger.
        self paint:(colors at:index).
        self fillRectangleX:xRounded y:0 width:wRounded height:height.

        string := percent rounded asInteger printString , '%'.
        (font widthOf:string) + 5 > wRounded ifTrue:[
            string := percent rounded asInteger printString
        ].
        (font widthOf:string) + 5 > wRounded ifFalse:[
            (percent > 50) ifTrue:[
                self paint:Black
            ] ifFalse:[
                self paint:White
            ].

            self displayString:string x:(xRounded + 5) y:20.
            self paint:Black.
            self displayRectangleX:xRounded y:0 width:wRounded height:height
        ].
        percent := percent + delta.
        x := x + w
    ]
! !
