StandardSystemView subclass:#PathDemo4
         instanceVariableNames:'elements'
         classVariableNames:''
         poolDictionaries:''
         category:'Demos-Tutorial'
!

PathDemo4 comment:'

Tutorial example - show use of path classes

execute: 
    PathDemo4 start

%W% %E%
written dec 92 by claus
'!

!PathDemo4 methodsFor:'initialization'!

initialize
    super initialize.

    self extent:(450 @ 450).
    self label:'Path Example4 (Arcs & Circles)'.

    self initElements

    "PathDemo4 start"
!

initElements
    |l p|

    elements := OrderedCollection new.

    l := Arc new form:(DrawingPen dotOfSize:5).
    l center:100@100 radius:50.
    l beginAngle:0 endAngle:135.
    elements add:l.

    l := Arc new form:(DrawingPen dotOfSize:2).
    l center:100@300 radius:75.
    l beginAngle:0 endAngle:300.
    elements add:l.

    l := Arc new.
    l center:300@300 radius:75.
    l beginAngle:0 endAngle:300.
    p := DrawingPen dotOfSize:4.
    p lineStyle:#doubleDashed.
    p paint:(Color red).
    p dashPaint:(Color white).
    l form:p.
    elements add:l.

    l := Circle new.
    l center:200@200 radius:50.
    p := DrawingPen dotOfSize:5.
    p lineStyle:#doubleDashed.
    p paint:(Color black).
    p dashPaint:(Color white).
    l form:p.
    elements add:l.

    l := Circle new.
    l center:300@100 radius:100.
    p := DrawingPen dotOfSize:5.
    p lineStyle:#dashed.
    p paint:(Color white).
    l form:p.
    elements add:l
! !

!PathDemo4 methodsFor:'redrawing'!

redraw
    elements do:[:aLine |
        aLine displayOn:self
    ]
! !
