"
 COPYRIGHT (c) 1989-92 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#PenDemo
       instanceVariableNames:'drawView bic'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

PenDemo comment:'
 play around with a pen - this example shows how widgets can be used
 from other classes.

 start with:
     PenDemo start

 %W% %E%
 written spring 89 by claus
'!

!PenDemo class methodsFor:'standalone startup'!

start
    self new start

    "PenDemo start"
! !

!PenDemo methodsFor:'startup'!

start
    |topView panel speedToggle nibToggle|

    topView := StandardSystemView
                    label:'PenDemo'
                    icon:(Form fromFile:'PenDemo.xbm').

    topView extent:(600 @ 400).
    topView minExtent:(600 @ 400).

    panel := PanelView origin:(0 @ 0) extent:(1.0 @ 1.0) in:topView.

    drawView := panel.

    bic := Pen in:drawView.

    Button label:'animated spiral' action:[self spiralAnimation:89 count:5] in:panel.
    Button label:'greyed spiral' action:[self spiralGreying:89] in:panel.
    Button label:'spiral 89' action:[self spiral:89] in:panel.
    Button label:'spiral 121' action:[self spiral:121] in:panel.
    Button label:'spiral 59' action:[self spiral:59] in:panel.
    Button label:'dragon' action:[self dragon] in:panel.
    Button label:'hilbert' action:[self hilbert] in:panel.
    Button label:'koch' action:[self koch] in:panel.
    Button label:'mandala' action:[self mandala] in:panel.
    Button label:'c-curve' action:[self cCurve] in:panel.

    speedToggle := Toggle label:'slow' in: panel.
    speedToggle pressAction:[Display unBuffered].
    speedToggle releaseAction:[Display buffered].

    nibToggle := Toggle label:'nib 1' in: panel.
    nibToggle pressAction:[bic defaultNib:5. nibToggle label:'nib 5'].
    nibToggle releaseAction:[bic defaultNib:1. nibToggle label:'nib 1'].

    Button label:'quit'  action:[topView destroy]  in:panel.

    topView open
! !

!PenDemo methodsFor:'private'!

nextColor

!PenDemo methodsFor:'geometric patterns'!

spiralGreying:angle
    drawView clear.
    0 to:100 by:10 do:[:grey |
        drawView paint:(Color grey:grey).
        bic home. bic east. bic spiral:400 angle:angle
    ].
    drawView paint:(Color black)
!

spiralAnimation:angle count:count
    drawView clear.
    count timesRepeat:[
        drawView paint:(Color black).
        bic home. bic east. bic spiral:400 angle:angle.
        drawView paint:(Color white).
        bic home. bic east. bic spiral:400 angle:angle
    ].
    drawView paint:(Color black)
!

spiral:angle
    drawView clear.
    bic home. bic east. bic spiral:400 angle:angle
!

dragon
    drawView clear.
    bic home. bic east. bic dragon:9
!

hilbert
    drawView clear.
    bic home.
    bic up.
    bic west. bic go:(drawView width // 5).
    bic north. bic go:(drawView height // 5).
    bic down.
    bic east. bic hilbert:5 side:8
!

koch
    drawView clear.
    bic home.
    bic up.
    bic west. bic go:(drawView width // 4).
    bic north. bic go:(drawView height // 5).
    bic down.
    bic east.
    bic koch:4 side:2.
    bic turn:120.
    bic koch:4 side:2.
    bic turn:120.
    bic koch:4 side:2
!

mandala
    drawView clear.
    bic home. bic east. bic mandala:10 radius:200
!

cCurve
    drawView clear.
    bic home. 
    bic up.
    bic west. bic go:(drawView width // 4).
    bic north. bic go:(drawView height // 4).
    bic down.
    bic east. bic cCurve:10 side:8
! !
