StandardSystemView subclass:#SliderDemo
       instanceVariableNames:'sliderRed sliderGreen sliderBlue
                              label1 label2 label3 
                              color colorForm
                              colorLabel'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

SliderDemo comment:'
 demonstrates use of sliders and colors -

 SliderDemo start

 %W% %E%
 written summer 92 by claus
'!

!SliderDemo class methodsFor:'startup'!

start
    |aDemo|

    aDemo := self 
                label:'SliderDemo'
                icon:(Form fromFile:'SliderDemo.xbm' resolution:100)
                minExtent:(160 @ 300)
                maxExtent:(1000 @ 1000).

    aDemo extent:(160 @ 300).
    aDemo open.
    ^ aDemo

    "SliderDemo start"
! !

!SliderDemo methodsFor:'initialization'!

initialize
    |l|

    super initialize.
    sliderRed := Slider origin:(20 @ 10) extent:(20 @ 150) in:self.
    sliderRed scrollAction:[:value | self sliderRed:value].

    sliderGreen := Slider origin:(70 @ 10) extent:(20 @ 150) in:self.
    sliderGreen scrollAction:[:value | self sliderGreen:value].

    sliderBlue := Slider origin:(120 @ 10) extent:(20 @ 150) in:self.
    sliderBlue scrollAction:[:value | self sliderBlue:value].

    l := Label origin:(10 @ 170) extent:[40 @ 20] in:self.
    l label:'r'.

    l := Label origin:(60 @ 170) extent:[40 @ 20] in:self.
    l label:'g'.

    l := Label origin:(110 @ 170) extent:[40 @ 20] in:self.
    l label:'b'.

    label1 := Label origin:(10 @ 200) extent:[40 @ 20] in:self.
    label1 level:-1.
    label1 label:'0'.

    label2 := Label origin:(60 @ 200) extent:[40 @ 20] in:self.
    label2 level:-1.
    label2 label:'0'.

    label3 := Label origin:(110 @ 200) extent:[40 @ 20] in:self.
    label3 level:-1.
    label3 label:'0'.

    colorLabel := Label origin:(10 @ 240) extent:[140 @ 40] in:self.
    colorLabel level:-1.

    colorForm := Form width:140 height:40 depth:(device depth).
    colorLabel form:colorForm.
    self setColorRed:0 green:0 blue:0
! !

!SliderDemo methodsFor:'private'!

setColorRed:r green:g blue:b
    color := Color red:r green:g blue:b.
    colorForm paint:color.
    colorForm fillRectangleX:0 y:0 width:(colorForm width)
                                  height:(colorForm height)
! !

!SliderDemo methodsFor:'user interaction'!

sliderRed:val
    label1 label:(val rounded asInteger printString).
    self setColorRed:val green:(color green) blue:(color blue).
    colorLabel redraw
!

sliderGreen:val
    label2 label:(val rounded asInteger printString).
    self setColorRed:(color red) green:val blue:(color blue).
    colorLabel redraw
!

sliderBlue:val
    label3 label:(val rounded asInteger printString).
    self setColorRed:(color red) green:(color green) blue:val.
    colorLabel redraw
! !
