simple objects:

  storing:
    |s|

    s := 'data.boss' asFilename writeStream binary.

    #aSymbol storeBinaryOn:s.
    'aString' storeBinaryOn:s.
    #(1 2 'three' #four (5 6 7)) storeBinaryOn:s.
    #( $a $b $c ) storeBinaryOn:s.
    s close

  retrieving:

    |s|

    s := 'data.boss' asFilename readStream binary.

    (Object readBinaryFrom:s) inspect.
    (Object readBinaryFrom:s) inspect.
    (Object readBinaryFrom:s) inspect.
    (Object readBinaryFrom:s) inspect.
    s close


complex objects:

  storing:
    |s a|

    s := 'data.boss' asFilename writeStream binary.

    a := Array new:5.
    a at:1 put:#(1 2 3 4 5).
    a at:2 put:#(1.0 2.0 3.0 4.0 5.0).
    a at:3 put:(Array with:1/2 with:1/3 with:1/4 with:1/5).
    a at:4 put:a.                      "direct self reference"
    a at:5 put:('foo' -> a).           "indirect self reference"
    a storeBinaryOn:s.

    s close

  retrieving:
    |s|

    s := 'data.boss' asFilename readStream binary.

    (Object readBinaryFrom:s) inspect.

    s close


complex objects:

  storing:
    |s|

    s := 'data.boss' asFilename writeStream binary.

    (Image fromFile:'bitmaps/claus.gif') storeBinaryOn:s.

    s close

  retrieving:
    |s|

    s := 'data.boss' asFilename readStream binary.

    (Object readBinaryFrom:s) inspect.

    s close


classes  (will store name only):

  storing:
    |s|

    s := 'data.boss' asFilename writeStream binary.

    Array storeBinaryOn:s.
    Image storeBinaryOn:s.

    s close

  retrieving:
    |s|

    s := 'data.boss' asFilename readStream binary.

    (Object readBinaryFrom:s) inspect.
    (Object readBinaryFrom:s) inspect.

    s close


methods  (will store a bytecode version):
    sorry, but currently blocks and methods with primitive code
    cannot be stored/recovered.

  storing:
    |s|

    s := 'data.boss' asFilename writeStream binary.

    Compiler compile:'
        foo 
          ^ Transcript showCr:''the foo method''
        '
        forClass:True.

    True storeBinaryOn:s.
    #foo storeBinaryOn:s.
    (True compiledMethodAt:#foo) storeBinaryOn:s.
    s close.
    true foo.
    True removeSelector:#foo.

  retrieving:

    "you will get an interpreter warning, when evaluating this 
     - ignore it and just press continue"

    |s class selector method|

    s := 'data.boss' asFilename readStream binary.
    class := (Object readBinaryFrom:s).
    selector := (Object readBinaryFrom:s).
    method := (Object readBinaryFrom:s).
    class addSelector:selector withMethod:method. 
    s close.
    true foo.
    True removeSelector:#foo.
