Object subclass:#BlockUnwindExample
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Blocks'
!

!BlockUnwindExample class methodsFor:'examples'!

example1
    "this method shows how the 'valueNowOrOnUnwindDo:' and
     'valueOnUnwindDo:' messages are used to make certain that
     cleanup actions are performed.

     'self doSomething' will be executed with a cleanup action defined (cleanup1).
     During the evaluation of doSomething, an error (halt) will happen.

     In the debugger select a context below (for example the example1-context) 
     and return it (or simply abort).
     See that the cleanup action (just a print) will be executed."

    [self doSomething]
        valueOnUnwindDo:['cleanup action1' printNewline].

    'normal exit' printNewline

    "BlockUnwindExample example1"
!

exampleHelper
    "just a helper for example3"

    self example1
!

example3
    "another example - see how both cleanup1 and cleanup3 actions
     will be performed in case of a resume"

    [self exampleHelper]
        valueNowOrOnUnwindDo:['cleanup action2' printNewline].

    'normal exit' printNewline

    "BlockUnwindExample example3"
!

doSomething
    "just a dummy action"

    self goDown:5 then:[self halt]
!

goDown:n then:aBlock
    n > 0 ifTrue:[
        ^ self goDown:n - 1 then:aBlock
    ].
    'now halting' printNewline.
    aBlock value.
    'after halt' printNewline
! !
