"this is a little demo of dynamic change in inheritance - its
 not a very good example, and (in smalltalk) dynamically changing
 inheritance is somewhat uncommon .... (in contrast to self)
 So this is NOT a demo of good programming style, but just a little
 demo (and test) that it can be done ....

 The interresting things is that the emptyCheck is fully done
 by dynamic inheritance - instead of checking the contents.
 (also the pop in Stack does not need an empty check, while a pop
  in EmptyStack is an unconditional error)

File in this code, and evaluate the expressions below ...
"!

"
   |s|

   s := Stack new.      
   Transcript show:'initial: '; showCr:s.
   s push:1.
   s push:2.
   Transcript show:'after push: '; showCr:s.
   Transcript show:'empty ?: '; showCr:(s isEmpty).
   s pop.
   s pop.
   Transcript show:'after pop: '; showCr:s.
   Transcript show:'empty ?: '; showCr:(s isEmpty).
"!

Object subclass:#Stack
         instanceVariableNames:'contents'
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Dynamic Inheritance'!

!Stack class methodsFor:'instance creation'!

new
    ^ super new initContents
! !

!Stack methodsFor:'private'!

initContents
    contents := OrderedCollection new.

    "I am actually an empty stack"
    self changeClassTo:EmptyStack
! !

!Stack methodsFor:'testing'!

isEmpty
    ^ false
!

size
    ^ contents size
! !

!Stack methodsFor:'accessing'!

push:anObject
    contents addLast:anObject
!

pop
    |o|

    o := contents removeLast.
    contents isEmpty ifTrue:[
        "I became an empty stack"
        self changeClassTo:EmptyStack
    ].
    ^ o
! !

Stack subclass:#EmptyStack
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Dynamic Inheritance'!

!EmptyStack methodsFor:'testing'!

isEmpty
    ^ true
!

size
    ^ 0
! !

!EmptyStack methodsFor:'accessing'!

push:anObject
    "no longer an empty stack"
    self changeClassTo:Stack.
    self push:anObject
!

pop
    ^ self error:'empty stack'
! !
