"this is a little demo of multiple inheritance - 
 ST/X supports an EXPERIMENTAL implementation of mixins, which
 allow adding other abstract classes to the superclass-set.
 Currently ONLY abstract classes can be added.
 This is EXPERIMENTAL - depending on what the testers say, 
 support for it it might be added into the VM
"

"
 the following change adds a second lookup in case of a
 doesNotUnderstand - effectively enabling MI
"
!

!Object methodsFor:'error handling'!

doesNotUnderstand:aMessage
    "enter debugger with does-not-understand-message"

    |errorString m|

    "this is an experimental implementation of Mixins
     (poor mans MI) - it will be moved into the VM if
     approved by the testers"

    m := self class lookupMethodFor:aMessage selector.
    m notNil ifTrue:[
        ^ m valueWithReceiver:self arguments:(aMessage arguments) selector:aMessage selector
    ].

    aMessage selector isNil ifTrue:[
        "happens when things go mad, or a method has been
         called by valueWithReceiver: with a wrong receiver"

        errorString := 'Message not understood: (nil)'
    ] ifFalse:[
        errorString := 'Message not understood: ' , aMessage selector
    ].
    MessageNotUnderstoodSignal
                raiseRequestWith:aMessage
                     errorString:errorString
!

baseClassResponsibility
    self error:'this method must be defined in the base class'
! !

"
 the actual MI classes:
 DerivedClass inherits both from BaseClass1 and BaseClass2 and Collection

 BaseClass2 adds #findFirst: to the protocol;
 Collection adds all enumeration stuff.
"

Object subclass:#BaseClass
         instanceVariableNames:'v1 v2'
         classVariableNames:''
         poolDictionaries:''
         category:'MI-demo'
!

!BaseClass methodsFor:'enumeration'!

do:aBlock
    aBlock value:v1.
    aBlock value:v2
! !

Object subclass:#BaseClass2
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'MI-demos'
!

!BaseClass2 methodsFor:'enumeration'!

do:aBlock
    self baseClassResponsibility
!

species
    ^ OrderedCollection
!

findFirst:aBlock
    self do:[:element |
        (aBlock value:element) ifTrue:[
           ^ element
        ]
    ].
    ^ nil
! !

BaseClass subclass:#DerivedClass
         instanceVariableNames:'v3'
         classVariableNames:''
         poolDictionaries:''
         category:'MI-demos'
!

DerivedClass addSuperclass:BaseClass2!
DerivedClass addSuperclass:Collection!

!DerivedClass class methodsFor:'instance creation'!

new
    ^ self basicNew initialize
! !

!DerivedClass methodsFor:'initialization'!

initialize
    v1 := 1.
    v2 := 2.
    v3 := 3

    "DerivedClass new"
! !

    "will lead to an error - BaseClass does not implement findFirst ..."
"
    BaseClass new findFirst:[:e | e printNewline. true]
"
    "will work as expected ..."
"
    DerivedClass new findFirst:[:e | e printNewline. true]
"
    "will lead to a funny error - since species is inherited from Object
     (not from BaseClass2), the collected-into object will be an instance
     of DerivedClass - which does not implement any add: method"

"
    DerivedClass new collect:[:e | e * 10]    
"
