'From Smalltalk/X, Version:2.9.2 on 13-mar-1994 at 6:21:24'!

Object subclass:#ContextDemos
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'tests'
!

!ContextDemos class methodsFor:'funny loop'!

while:condition do:aBlock
    "
     how while loops could be implemented
    "

    condition value ifFalse:[^ false].
    aBlock value.
    thisContext restart.

    "
     |count|
     count := 1.
     ContextDemos while:['test' print. count printNewline. count <= 5]
                     do:[count printNewline.
                         count := count + 1
                        ]
    "
!

loop:aBlock while:cond
    cond value ifFalse:[thisContext return].
    aBlock value.
    thisContext restart

    "
     |n|

     n := 1.
     ContextDemos loop:[n printNewline. n := n + 1] while:[n <= 10]
    "
!

blockWithExit
    1 to:10 do:[:i |
        '<:' print. i printNewline.
        i == 5 ifTrue:[thisContext return].  "exists the block - not the loop"
        '>:' print. i printNewline.
    ].
    "
     ContextDemos blockWithExit
    "
! 

blockWithLoopExit
    1 to:10 do:[:i |
        '<:' print. i printNewline.
        i == 5 ifTrue:[thisContext sender return].  "exists the loop"
        '>:' print. i printNewline.
    ].

    "
     ContextDemos blockWithLoopExit
    "
! 

resumeExample
    'm-a' printNewline.
    self resumeHelper1.
    'm-b' printNewline.

    "
     ContextDemos resumeExample
    "
!

resumeHelper1
    'h1-a' printNewline.
    self resumeHelper2.
    'h1-b' printNewline
!

resumeHelper2
    'h2-a' printNewline.
    thisContext sender sender resume.
    'h2-b' printNewline
! 

returnExample
    'm-a' printNewline.
    self returnHelper1.
    'm-b' printNewline.

    "
     ContextDemos returnExample
    "
!

returnHelper1
    'h1-a' printNewline.
    self returnHelper2.
    'h1-b' printNewline
!

returnHelper2
    'h2-a' printNewline.
    thisContext sender return.
    'h2-b' printNewline
! !

!ContextDemos class methodsFor:'timing'!

timeContext
    |cnt|

    "have to trick, to avoid inlining"
    cnt := 10000.
    [cnt > 0] perform:#whileTrue: with:[cnt := cnt - 1]
!

timeTraditional
    |cnt|

    "have to trick, to avoid inlining"
    cnt := 10000.
    [cnt > 0] perform:#OLDwhileTrue: with:[cnt := cnt - 1]
! !

"


                                                        486/50   NeXT   hppa

 Time millisecondsToRun:[ContextDemos timeContext]        685    
 Time millisecondsToRun:[ContextDemos timeTraditional]    673    
"
