Object subclass:#RegistryExample
         instanceVariableNames:'myName'
         classVariableNames:'Lobby'
         poolDictionaries:''
         category:'Examples-Registry'
!

!RegistryExample class methodsFor:'examples'!

example1
    "this creates objects, which, when destroyed print a message on the Transcript.
     (actually a phantom is doing this, but who cares)"

    |o1 o2 o3 o4 o5|

    o1 := (self new name:'object1').
    o2 := (self new name:'object2').
    o3 := (self new name:'object3').
    o4 := (self new name:'object4').
    o5 := (self new name:'object5').

    Lobby isNil ifTrue:[
        Lobby := Registry new.
    ].

    Transcript showCr:'add o1 ...'.
    Lobby register:o1.
    Transcript showCr:'add o2 ...'.
    Lobby register:o2.
    Transcript showCr:'add o3 ...'.
    Lobby register:o3.
    Transcript showCr:'add o4 ...'.
    Lobby register:o4.
    Transcript showCr:'add o5 ...'.
    Lobby register:o5.

    "they are still living ..."

    Transcript showCr:'nothing happens now ...'.
    ObjectMemory scavenge.

    "now, one of them should scream ..."

    Transcript showCr:'now, o3 should scream ...'.
    o3 := nil.
    ObjectMemory scavenge.

    "now, another one should scream ..."

    Transcript showCr:'now, o1 should scream ...'.
    o1 := nil.
    ObjectMemory scavenge.

    "the rest will shout sometime after this ..."

    Transcript showCr:'the others will follow soon (when next garbage collect occures).'.

    "RegistryExample example1"
! !

!RegistryExample methodsFor:'setup'!

name:aString
    myName := aString
! !

!RegistryExample methodsFor:'printing'!

printString
    ^ self class name , '-' , myName 
! !

!RegistryExample methodsFor:'instance destruction'!

disposed
    Transcript showCr:myName , ' was destroyed'
! !
