to communicate using Sockets, use:

TCP connections:

on host1:    (server providing a service)


    |sock conn|

    sock := Socket provide:9995.
    sock notNil ifTrue:[
          "((optional:  sock readWait))"
          conn := Socket acceptFrom:sock.
          sock close.
    ].
    ^ conn

on host2:    (client)

    |conn|

    conn := Socket connectTo:9995 on:'host1'
    ^ conn


To send data:

    conn nextPutAll:'hello'

to receive data:

    conn next:n

its a good idea to make the Streams unbuffered with: 'conn buffered:false'
to avoid buffering by the stdio library 
(you may wonder where your data goes otherways)


example (transfering a block of bytes):

    "host 1 (server), sendding data:"

    |sock conn bytes|

    bytes := ByteArray withAll:(1 to:30).
    'providing socket service ...' printNewline.
    sock := Socket provide:9995.
    sock notNil ifTrue:[
          "((optional:  sock readWait))"
          'waiting for a client ...' printNewline.
          conn := Socket acceptFrom:sock.
          sock close.
    ].
    conn isNil ifTrue:[
        'socket setup failed' printNewline
    ] ifFalse:[
        'connected; send data ...' printNewline.
        conn binary.
        conn nextPutAll:bytes.
        conn close.
        'done.' printNewline.
    ]


"------------------------------------------------------------"
    "host 2 (client), receiving data:"

    |conn buffer count|

    buffer := ByteArray new:100.
    'connecting to server ...' printNewline.
    conn := Socket connectTo:9995 on:'hp' "'host1'".
    conn isNil ifTrue:[
        'connect failed' printNewline
    ] ifFalse:[
        'connected; receive data ...' printNewline.
        conn binary.
        count := conn nextBytes:100 into:buffer.
        'received ' print. count print. ' bytes' printNewline.
        buffer printNewline.
        conn close.
    ].
