to send objects using Sockets, use:

on host1:    (server providing a service, sending objects)


    |sock conn|

    'providing socket service ...' printNewline.
    sock := Socket provide:9995.
    sock notNil ifTrue:[
          'waiting for a client ...' printNewline.
          conn := Socket acceptFrom:sock.
          sock close.
    ].
    conn isNil ifTrue:[
        'socket setup failed' printNewline
    ] ifFalse:[
        'connected; send objects...' printNewline.
        conn buffered:false; binary.
        #(1 2 'three' #four (5 6 7))         storeBinaryOn:conn.
        #( $a $b $c )                        storeBinaryOn:conn.
        (Image fromFile:'bitmaps/claus.gif') storeBinaryOn:conn.
        conn close.
        'done.' printNewline.
    ]

on host2:    (client, connecting and receiving objects)

    |conn|

    'connecting to server ...' printNewline.
    conn := Socket connectTo:9995 on:'hp'  "'host1'".
    conn isNil ifTrue:[
        'connect failed' printNewline
    ] ifFalse:[
        'connected' printNewline.
        conn buffered:false; binary.

        "optional:  conn readWait. "
        (BinaryInputManager readFrom:conn) inspect.
        (BinaryInputManager readFrom:conn) inspect.
        (BinaryInputManager readFrom:conn) inspect.
        conn close
    ]


alternative (read all that comes):

    |conn o|

    'connecting to server ...' printNewline.
    conn := Socket connectTo:9995 on:'hp' "'host1'".
    conn isNil ifTrue:[
        'connect failed' printNewline
    ] ifFalse:[
        'connected' printNewline.
        conn buffered:false; binary.

        [conn atEnd] whileFalse:[
            conn readWait.
            'something arrived ...' printNewline.
            o := Object readBinaryFrom:conn.
            'received ' , o classNameWithArticle , '.' printNewline.
        ].
        conn close
    ]
