StandardSystemView subclass:#Example8
       instanceVariableNames:'subview menu'
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-Tutorial'
!

Example8 comment:'

Tutorial example - a view with a subview and a menu;
also on the fly, you see how notify: and confirm: messages are used.

%W% %E%
written spring 92 by claus
'!

!Example8 methodsFor:'initialization'!

initialize
    |hPixelPerMM vPixelPerMM|

    super initialize.

    self label:'Turorial Example8'.

    menu := PullDownMenu in:self.
    menu labels:#('foo' 'bar' 'baz').
    menu at:1
            putLabels:#(
                        'foo' 
                        'foobar' 
                        '-' 
                        'quit'
                       )
            selectors:#(
                        doFoo
                        doFoobar
                        nil 
                        finish
                       )
             receiver:self.

    menu at:2
            putLabels:#(
                        'bar' 
                        'barfoo'
                       )
            selectors:#(
                        doBar 
                        doBarfoo
                       )
             receiver:self.

    menu at:3
            putLabels:#(
                        'baz' 
                        'bazfoo'
                       )
            selectors:#(
                        doBaz 
                        doBazfoo
                       )
             receiver:self.

    hPixelPerMM := self horizontalPixelPerMillimeter rounded asInteger.
    vPixelPerMM := self verticalPixelPerMillimeter rounded asInteger.

    subview := TextView origin:(hPixelPerMM @ (menu height + vPixelPerMM))
                        extent:[(width - (hPixelPerMM * 2))
                                 @ 
                                (height - (menu height) - (vPixelPerMM * 2))]
                            in:self.
    subview level:-1.
    subview contents:'
This is an example of a view with a pull-down-menu.

It also demonstrates the use of Notifier and Confirmer -
try the different menu entries and you will see ....
(some menu entries will pop-up a notifier, some a confirmer
 and others will just output something to the Transcript)


To finish, use quit from the foo-menu.'

    "Example8 start"
! !

!Example8 methodsFor:'user interaction'!

finish
    self destroy
!

doFoo
    self notify:'its a foo'
!

doFoobar
    Transcript showCr:'you selected; foobar'
!

doBar
    self notify:'it was: bar'
!

doBarfoo
    Transcript showCr:'barfoo'
!

doBaz
    (self confirm:'do you really want to: baz') ifTrue:[
        Transcript showCr:'yes I want a baz'
    ] ifFalse:[
        Transcript showCr:'no I dont need any baz (what is a baz anyway ?)'
    ]
!

doBazfoo
    Transcript showCr:'bazfoo'
! !
