StandardSystemView subclass:#Example9
         instanceVariableNames:'menu myView'
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Tutorial'
!

Example9 comment:'

Tutorial example - a complete setup for a scrollable view with a menu.
The menu is NOT nationalized using resources.

written spring 92 by claus
'!

!Example9 methodsFor:'initialize / release'!

initialize
    "setup view"

    |menu scrollingView|

    super initialize.

    self label:'Tutorial Example 9'.

    menu := PullDownMenu in:self.
    menu labels:#('Datei' 'Bearbeiten').

    menu at:'Datei'
            putLabels:#('neu' 
                        'ffnen ..' 
                        '-' 
                        'sichern' 
                        'sichern unter ...' 
                        '-' 
                        'drucken'
                        '-' 
                        'beenden')
            selectors:#(doNew doOpen nil 
                        doSave doSaveAs nil doPrint
                        nil destroy)
             receiver:self.

    menu at:'Bearbeiten'
            putLabels:#('kopieren' 
                        'lschen' 
                        'einsetzen')
            selectors:#(copySelection cutSelection pasteBuffer)
             receiver:self.

    scrollingView := HVScrollableView for:View in:self.
    scrollingView origin:(0 @ menu height)
                  extent:[width @ (height - menu height)].
    myView := scrollingView scrolledView

   "Example9 start"

! !

!Example9 methodsFor:'user interaction'!

doNew
    Transcript showCr:'new'
!

doOpen
    |box|

    box := FileSelectionBox new.
    box title:'Read file:'.
    box action:[:fileName | Transcript showCr:'open ' , fileName].
    box show.
!

doSave
    Transcript showCr:'save'
!

doSaveAs
    |box|

    box := FileSaveBox new.
    box title:'Save as:'.
    box action:[:fileName | Transcript showCr:'save as ' , fileName , ' (not really)'].
    box show.
!

doPrint
    Transcript showCr:'print'
!

copySelection
    Transcript showCr:'copy'
!

cutSelection
    Transcript showCr:'cut'
!

pasteBuffer
    Transcript showCr:'paste'
! !
