Object subclass:#FrameExample5
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Tutorial'
!

FrameExample5 comment:'

Tutorial example - a complex view with 2 frames and some action

to show: fileIn this code;
execute: FrameExample5 start
destroy with WindowManager.

%W% %E%
written oct 92 by claus
'!

!FrameExample5 class methodsFor:'startup'!

start
    self basicNew initialize
! !

!FrameExample5 methodsFor:'initialization'!

initialize
    |topView topPanel frame1 frame2 list commentView buttonPanel v|

    topView := StandardSystemView new.
    topView label:'ClassList Frame Example'.

    topPanel := VariableHorizontalPanel 
                origin:(0.0 @ 0.0)
                extent:(1.0 @ 1.0)
                    in:topView.

    frame1 := FramedBox origin:(0.0 @ 0.0) corner:(0.3 @ 1.0) in:topPanel.
    frame1 label:'classes'.

    frame2 := FramedBox origin:(0.3 @ 0.0) corner:(1.0 @ 1.0) in:topPanel.
    frame2 label:'comment'.

    v := ScrollableView for:SelectionInListView in:frame1.
    v origin:(0.0 @ 0.0) extent:(1.0 @ 1.0).
    list := v scrolledView.

    v := ScrollableView for:TextView in:frame2.
    v origin:(0.0 @ 0.0) extent:(1.0 @ 1.0).
    commentView := v scrolledView.

    list list:(Smalltalk allClasses collect:[:aClass | aClass name]) asOrderedCollection sort.
    list action:[:selNr |
        | className class |
        className := list selectionValue.
        class := Smalltalk at:(className asSymbol).
        commentView contents:class comment
    ].

    topView open

    "FrameExample5 start"
! !
