Object subclass:#FrameExample6
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Examples-Tutorial'
!

FrameExample6 comment:'

Tutorial example - a complex view with 2 frames and some action

to show: fileIn this code;
execute: FrameExample6 start
destroy with WindowManager.

%W% %E%
written oct 92 by claus
'!

!FrameExample6 class methodsFor:'startup'!

start
    self basicNew initialize
! !

!FrameExample6 methodsFor:'initialization'!

initialize
    |topView topPanel frame1 frame2 list fileView buttonPanel v|

    topView := StandardSystemView new.
    topView label:'FileList Frame Example'.

    topPanel := VariableHorizontalPanel 
                origin:(0.0 @ 0.0)
                extent:(1.0 @ 1.0)
                    in:topView.

    frame1 := FramedBox origin:(0.0 @ 0.0) corner:(0.3 @ 1.0) in:topPanel.
    frame1 label:'files'.

    frame2 := FramedBox origin:(0.3 @ 0.0) corner:(1.0 @ 1.0) in:topPanel.
    frame2 label:'contents'.

    v := ScrollableView for:SelectionInListView in:frame1.
    v origin:(0.0 @ 0.0)extent:(1.0 @ 1.0).
    list := v scrolledView.

    v := ScrollableView for:TextView in:frame2.
    v origin:(0.0 @ 0.0)extent:(1.0 @ 1.0).
    fileView := v scrolledView.

    list list:(FileDirectory currentDirectory files).
    list action:[:selNr |
        | fileName |
        fileName := list selectionValue.
        fileView contents:(FileStream readonlyFileNamed:fileName) contents
    ].

    topView open

    "FrameExample6 start"
! !
