StandardSystemView subclass:#PopUpMenuDemo3
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Demos'
!

PopUpMenuDemo3 comment:'
 how to define menus with submenus

 %W% %E%
 written spring 91 by claus
'!

!PopUpMenuDemo3 class methodsFor:'startup'!

start
    |aDemo|

    aDemo := self
                label:'PopUpMenu Demo'
                icon:(Form fromFile:'Demo.xbm' resolution:100)
                minExtent:(50 @ 50)
                maxExtent:(1000 @ 1000).
    aDemo extent:(300 @ 100).
    aDemo open.
    ^ aDemo

    "PopUpMenuDemo3 start"
! !

!PopUpMenuDemo3 methodsFor:'initialization'!

initialize
    |myLabel myButton|

    super initialize.
    myLabel := Label origin:(0.0 @ 0.0) extent:(1.0 @ 1.0) in:self.
    myLabel label:'press middle button for menu'.
!

initializeMiddleButtonMenu
    |aMenu subMenu subSubMenu|

    aMenu := PopUpMenu
                labels:#(
                         'one'
                         'two'
                         'three'
                         '-'
                         'quit'
                        )
             selectors:#(
                         subMenu
                         twoSelected
                         threeSelected
                         nil
                         finish
                        )
              receiver:self.

    subMenu := PopUpMenu
                  labels:#(
                           'one.one'
                           'one.two'
                           'even more'
                          )
               selectors:#(
                           oneOneSelected
                           oneTwoSelected
                           subSubMenu
                          )
                receiver:self.

    subSubMenu := PopUpMenu
                  labels:#(
                           'one.three.one'
                           'one.three.two'
                           'thats enough'
                          )
               selectors:#(
                           oneThreeOneSelected
                           oneThreeTwoSelected
                           oneThreeThreeSelected
                          )
                receiver:self.

    aMenu subMenuAt:#subMenu put:subMenu.
    subMenu subMenuAt:#subSubMenu put:subSubMenu.
"
you can also specify submenus as:

    aMenu subMenuAt:'one ...' put:subMenu.
or:
    aMenu subMenuAt:1 put:subMenu
"

    self middleButtonMenu:aMenu
! !

!PopUpMenuDemo3 methodsFor:'user interaction'!

oneOneSelected
    Transcript showCr:'function 1.1'
!

oneTwoSelected
    Transcript showCr:'function 1.2'
!

oneThreeOneSelected
    Transcript showCr:'function 1.3.1'
!

oneThreeTwoSelected
    Transcript showCr:'function 1.3.2'
!

oneThreeThreeSelected
    Transcript showCr:'function 1.3.3'
!

twoSelected
    Transcript showCr:'function 2'
!

threeSelected
    Transcript showCr:'function 3'
!

finish
    self destroy
! !
