StandardSystemView subclass:#ShapeView2
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-Views'
!

ShapeView2 comment:'
 demonstrates how arbitrary patterns can be used as shape
 in this example, a bitmaps 1-bits are taken as view shape,
 effectively creating a somewhat transparent view.

 This works only, if your X-server supports the XShape
 extension - which is usually the case.

 However, the motif window manager does NOT support it
 (I dont know about the newest version though ..)

 Be prepared, that most X-servers have performance problems
 handling this kind of view-shape ...

 start with:

 ShapeView2 new open

 %W% %E%
 written mar 94 by claus
'!

!ShapeView2 methodsFor:'initialization'!

initialize
    super initialize.
    self label:'a funny shape'.
    self viewBackground:Color black.
    self computeShape

    "ShapeView2 new open"
! !

!ShapeView2 methodsFor:'handling size changes'!

sizeChanged:how
    "must compute a new shape, when size is changed"

    self computeShape.
    super sizeChanged:how
! !

!ShapeView2 methodsFor:'shape computation'!

computeShape
    "define a funny shape"

    |form|

    form := (Image fromFile:'bitmaps/claus.gif') asMonochromeFormOn:Display.
    self extent:form extent.
    self borderShape:form.
    self viewShape:form
! !
