StandardSystemView subclass:#ShapeView1
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Examples-Views'
!

ShapeView1 comment:'
 demonstrates how round views are created
 This works only, if your X-server supports the XShape
 extension - which is usually the case.

 However, the motif window manager does NOT support it
 (I dont know about the newest version though ..)

 start with:

 ShapeView1 new open

 %W% %E%
 written mar 94 by claus
'!

!ShapeView1 methodsFor:'initialization'!

initialize
    super initialize.
    self label:'a round view'.
    self viewBackground:Color white.
    self computeShape

    "ShapeView1 new open"
! !

!ShapeView1 methodsFor:'handling size changes'!

sizeChanged:how
    "must compute a new shape, when size is changed"

    self computeShape.
    super sizeChanged:how
! !

!ShapeView1 methodsFor:'shape computation'!

computeShape
    "
     computes 2 forms, one for the border, the other
     for the inside area.
     The border form is borderwidth*2 pixels larger.
     Each form gets filled with an ellipse of 1-pixels,
     to define the shapes (take a look at the XShape spec,
     for more info)
    "

    |extent shapeForm borderForm bw|

    extent := self extent.
    borderForm := Form width:(extent x) height:(extent y).
    borderForm fill:(Color colorId:0).
    shapeForm := Form width:(extent x) height:(extent y).
    shapeForm fill:(Color colorId:0).

    borderForm foreground:(Color colorId:1).
    borderForm fillArcX:0 y:0 
                      w:(borderForm width)
                      h:(borderForm height)
                   from:0
                  angle:360.
    bw := 3.
    shapeForm foreground:(Color colorId:1).
    shapeForm fillArcX:bw y:bw 
                     w:(shapeForm width - (bw * 2))
                     h:(shapeForm height - (bw * 2))
                   from:0
                  angle:360.
    self borderShape:borderForm.
    self viewShape:shapeForm
! !
