"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass: #BinaryObjectStorage
        instanceVariableNames: 'manager stream'
        classVariableNames: ''
        poolDictionaries: ''
        category: 'System-Support'
!

!BinaryObjectStorage class methodsFor: 'documentation'!

documentation
"
This class provides an ST-80 compatible (I hope) interface to
BinaryInput- and BinaryOutputManager.
The protocol is not complete, PP seems to offer more (skip etc.)
this will be added as time goes by ...

example (taken from an article in comp.lang.smalltalk):

  storing:

    |bos testArray |

    testArray := Array new: 4.
    1 to: 4 do: 
        [:index |
        | interArray |
        interArray := Array new: 10.
        1 to: 10 do:
                [:interIndex |
                | innerArray |
                innerArray := Array new: 1000 withAll: 0.
                interArray at: interIndex put: innerArray].
        testArray at: index put: interArray
    ].

    bos := BinaryObjectStorage onNew: (Filename named: 'array.boss') writeStream.
    bos nextPut: testArray.
    bos nextPut: #(1 2 3 4).
    bos nextPut: 'hello'.
    bos close.

  retrieving:

    |bos obj1 obj2 obj3|
    bos := BinaryObjectStorage onOld: (Filename named: 'array.boss') readStream.
    obj1 := bos next.
    obj2 := bos next.
    obj3 := bos next.
    bos close.
    obj1 inspect.
    obj2 inspect.
    obj3 inspect.
"
! !

!BinaryObjectStorage class methodsFor: 'instance creation'!

onOld:aStream
    ^ self new onOld:aStream
!

onNew:aStream
    ^ self new onNew:aStream
! !

!BinaryObjectStorage methodsFor: 'private'!

onOld:aStream
    stream := aStream.
    stream binary.
    manager := BinaryInputManager new:1024.
!

onNew:aStream
    stream := aStream.
    stream binary.
    manager := (BinaryOutputManager new:1024) initialize.
! !

!BinaryObjectStorage methodsFor: 'object io'!

next
    "read and return the next object"

    ^ manager readFrom:stream
!

nextPut:anObject
    "write an object"

    anObject storeBinaryOn: stream manager: manager
!

close
    stream close
! !
