"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#BitBlt
       instanceVariableNames:'source destForm halftoneForm defaultNib
                              combinationRule destOrigin sourceOrigin extent clipRect'
       classVariableNames:''
       poolDictionaries:''
       category:'Graphics-Support'
!

BitBlt comment:'
just for making pen look smalltalk-alike

%W% %E%
written spring/summer 89 by claus
'!

!BitBlt class methodsFor:'instance creation'!

new
    |newBitBlt|
    newBitBlt := super new.
    RootView isNil ifTrue:[
        RootView := DisplayRootView on:Display
    ].
    newBitBlt source:RootView.
    newBitBlt destForm:RootView.
    ^ newBitBlt initialize
!

in:aDrawable
    |newBitBlt|
    newBitBlt := super new.
    newBitBlt source:aDrawable.
    newBitBlt destForm:aDrawable.
    ^ newBitBlt initialize
!

destForm:dForm sourceForm:sForm halftoneForm:hForm combinationRule:rule
               destOrigin:dOrg sourceOrigin:sOrg extent:ext
                 clipRect:clip
    "for compatibility - not really supported"

    ^ self basicNew
        destForm:dForm sourceForm:sForm halftoneForm:hForm 
                  combinationRule:rule
                       destOrigin:dOrg sourceOrigin:sOrg extent:ext
                         clipRect:clip
! !

!BitBlt methodsFor:'initialization'!

initialize
    ^ self
! !

!BitBlt methodsFor:'accessing'!

destForm:dForm sourceForm:sForm halftoneForm:hForm combinationRule:rule
               destOrigin:dOrg sourceOrigin:sOrg extent:ext
                 clipRect:clip
    destForm := dForm.
    source := sForm.
    halftoneForm := hForm.
    combinationRule := rule.
    destOrigin := dOrg.
    sourceOrigin := sOrg.
    extent := ext.
    clipRect := clip
!

defaultNib:aNumber
    source := nil.
    defaultNib := aNumber.
    defaultNib notNil ifTrue:[
        (defaultNib == 1) ifTrue:[
            destForm lineWidth:0
        ] ifFalse:[
            destForm lineWidth:defaultNib
        ]
    ]
!

source:aDrawable
    source := aDrawable.
    defaultNib := nil
!

sourceForm:aDrawable
    source := aDrawable.
    defaultNib := nil
!

destForm:aDrawable
    (aDrawable == Display) ifTrue:[
        destForm := RootView
    ] ifFalse:[
        destForm := aDrawable
    ]
!

frame:aFrame
    ^ self
!

combinationRule:aRule
    combinationRule := aRule
!

sourceOrigin:aPoint
    sourceOrigin := aPoint
!

destOrigin:aPoint
    destOrigin := aPoint
! !

!BitBlt methodsFor:'bit-blitting'!

copyBits
    destForm copy:(Rectangle origin:destOrigin extent:extent)
             from:sourceOrigin
               in:source
             rule:combinationRule
! !

!BitBlt methodsFor:'drawing'!

drawFrom:startPoint to:stopPoint
    defaultNib notNil ifTrue:[
        destForm displayLineFrom:startPoint to:stopPoint
    ] ifFalse:[
        "need copy loop here to draw source along line ..."
        ^ self
    ]
!

drawFromX:startX y:startY toX:stopX y:stopY
    defaultNib notNil ifTrue:[
        destForm displayLineFromX:startX y:startY toX:stopX y:stopY
    ] ifFalse:[
        "need copy loop here to draw source along line ..."
        ^ self
    ]
!

copyFromX:x y:y width:w height:h
    destForm copyFrom:source x:x y:y width:w height:h
! !
