"       NAME            Paths
        AUTHOR          scaletti@uxc.cso.uiuc.edu (Kurt J. Hebel)
        FUNCTION        Reimplementation of the Path hierarchy
        ST-VERSION      2.2?
        PREREQUISITES   
        CONFLICTS       
        DISTRIBUTION    world
        VERSION         1
        DATE    3 Jun 1987
"

Arc subclass: #Circle
        instanceVariableNames: ''
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics-Paths'
!

Circle comment:
'This class implements general ellipses given a center point and a radius point
 (which gives the x and y radius).'
!


!Circle methodsFor: 'accessing'!

beginAngle: aNumber
        "Set the beginning angle of this Circle.  Give an error if not 0 degrees."

        aNumber ~= 0 ifTrue: [self angleError].
        beginAngle _ aNumber.
!

beginAngle: angle1 endAngle: angle2
        "Set the beginning and ending angles of this Circle.  Give an error if not 0
         and 360 degrees, respectively."

        angle1 ~= 0 | (angle2 ~= 360) ifTrue: [self angleError].
        beginAngle _ angle1.
        endAngle _ angle2.
!

endAngle: aNumber
        "Set the ending angle of this Circle.  Give an error if not 360 degrees."

        aNumber ~= 360 ifTrue: [self angleError].
        endAngle _ aNumber.
! !

!Circle methodsFor: 'private'!

angleError
        self error: 'Illegal beginAngle or endAngle.'.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

!Circle class methodsFor: 'instance creation'!

new
        "Return a new Circle."
        | aCircle |

        aCircle _ super new.
        aCircle beginAngle: 0.
        aCircle endAngle: 360.
        ^ aCircle! !


" The above file is a Manchester Goodie.  It is distributed freely on condition
 that you observe these conditions in respect of the whole Goodie, and on
 any significant part of it which is separately transmitted or stored:
        * You must ensure that every copy includes this notice, and that
          source and author(s) of the material are acknowledged.
        * These conditions must be imposed on anyone who receives a copy.
        * The material shall not be used for commercial gain without the prior
          written consent of the author(s).

 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
        To: goodies-lib@cs.man.ac.uk
        Subject: help 
"!
