TreeView subclass:#ClassTreeView
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

ClassTreeView comment:'
 a small application showing an ObjectView / TreeView use

 must fileIn TreeView.st first,
 then start with:
     ClassTreeView start

 %W% %E%
 written spring 91 by claus
'!

!ClassTreeView class methodsFor:'startup'!

start
    |aDemo topView v|

    topView := StandardSystemView 
                    label:'Class hierarchy'
                    icon:(Form fromFile:'Demo.icon' resolution:100).
    v  := HVScrollableView for:self in:topView.
    v origin:(0 @ 0) extent:(1.0 @ 1.0).

    topView open

    "ClassTreeView start"
! !

!ClassTreeView methodsFor:'initialization'!

initialize
    topNode := Object.
    super initialize.
!

initializeMiddleButtonMenu
    |labels|

    labels := resources array:#(
                        'browse'
                        'browse hierarchy'
                        '-'
                        'category'
                        'comment'
                        'definition'
                       ).

    self middleButtonMenu:(PopUpMenu
                                labels:labels
                             selectors:#(startBrowser
                                         startHierarchyBrowser
                                         nil
                                         showCategory
                                         showComment
                                         showDefinition
                                        )
                                receiver:self
                                     for:self)
! !

!ClassTreeView methodsFor:'generating the class-tree picture'!

childrenOf:aClass do:aBlock
    |subclassNames|

    subclassNames := OrderedCollection new.
    aClass subclassesDo:[:aSubclass |
        subclassNames add:aSubclass name
    ].
    (subclassNames size ~~ 0) ifTrue:[
        subclassNames sort.
        subclassNames do:[:aName |
            aBlock value:(Smalltalk at:(aName asSymbol))
        ]
    ]
!

textFor:aClass
    ^ aClass name
! !

!ClassTreeView methodsFor:'user interaction'!

startBrowser
    self withSelectedElementDo:[:theClass |
         SystemBrowser browseClass:theClass
    ]
!

startHierarchyBrowser
    self withSelectedElementDo:[:theClass |
         SystemBrowser browseClassHierarchy:theClass
    ]
!

showCategory
    self withSelectedElementDo:[:theClass |
         self notify:(theClass category printString)
    ]
!

showComment
    self withSelectedElementDo:[:theClass |
         self notify:(theClass comment printString)
    ]
!

showDefinition
    |s|

    self withSelectedElementDo:[:theClass |
        s := WriteStream on:String new.
        theClass fileOutDefinitionOn:s.
        self notify:s contents
    ]
! !
