"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

View subclass:#ColorPanel
       instanceVariableNames:'rgbPanel hlsPanel wheel
                              myColor labelView labelColor'
       classVariableNames:''
       poolDictionaries:''
       category:'Views-Interactors'
!

ColorPanel comment:'
 color mixer

ColorPanel new realize
 $Header: /claus/smalltalk/st2.6/clients/ColorPanel/RCS/ColorPanel.st,v 1.1 93/10/25 10:44:02 claus Exp $
 written june 93 by claus
'!

!ColorPanel class methodsFor:'defaults'!

defaultExtent
    ^ 530 @ 170
! !

!ColorPanel methodsFor:'initialization'!

initialize
    |l h sep r helper wl|

    super initialize.

    "just to have a spare color"
    myColor := (Color red:70 green:20 blue:90) on:device.
    labelColor := Black.

    labelView := Label origin:0.85 @ 0.05
                       corner:0.99 @ 0.95
                           in:self.
    labelView viewBackground:Black.
    labelView level:0; borderWidth:1.

    wheel := ColorWheel origin:0.0 @ 0.0
                        corner:0.3 @ 1.0
                            in:self.
    wheel action:[:color | self setColorFromWheel:color].

    rgbPanel := RGBPanel origin:0.3 @ 0.0
                         corner:0.8 @ 0.5
                             in:self.
    rgbPanel action:[:r :g :b | self setRed:r green:g blue:b].

    hlsPanel := HLSPanel origin:0.3 @ 0.5
                         corner:0.8 @ 1.0
                             in:self.
    hlsPanel action:[:h :l :s | self setHue:h light:l saturation:s].
! !

!ColorPanel methodsFor:'actions'!

setLabelColor:aColor
    |clr sameColor|

    sameColor := (clr = labelColor).
    sameColor ifFalse:[
        clr := aColor on:device.
        sameColor := (clr colorId == labelColor colorId).
        sameColor ifTrue:[
            clr colorId isNil ifTrue:[
                sameColor := (clr ditherForm == labelColor ditherForm).
            ]
        ]
    ].
    sameColor ifFalse:[
        labelColor := clr.
        labelView backgroundColor:clr.
        labelView redraw.

        "I'd like to do this ...

        hlsPanel saturationSlider color:(Color hue:(aColor hue roundTo:30) light:50 saturation:100)

        ... but currently color dither code is way too slow to do it. ;-)"
    ]
!

setColor:color
"
    color printNewline.
"
    myColor := color.
    hlsPanel setFrom:color.
    rgbPanel setFrom:color.
    self setLabelColor:color.
    wheel color:color
!

setColorFromWheel:color
"
    color printNewline.
"
    myColor := color.
    hlsPanel setFrom:color.
    rgbPanel setFrom:color.
    self setLabelColor:color.
!

setRed:r green:g blue:b
"
    'rgb: ' print. r print. ' ' print. g print. ' ' print. b printNewline.
"
    myColor := Color red:r green:g blue:b.
    hlsPanel setFrom:myColor.
    self setLabelColor:myColor.
    wheel color:myColor
!

setHue:h light:l saturation:s
"
    'hls: ' print. h print. ' ' print. l print. ' ' print. s printNewline.
"
    myColor := Color hue:h light:l saturation:s.
    rgbPanel setFrom:myColor.
    self setLabelColor:myColor.
    wheel color:myColor
! !
