"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Array subclass:#Commander
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Graphics-Support'
!

Commander comment:'
@(#)Commander.st        1.2 92/08/23
'!

!Commander class methodsFor:'instance creation'!

new:numberOfPens
    |newCommander|
    newCommander := super new:numberOfPens.
    1 to:numberOfPens do:[ :index |
        newCommander at:index put:Pen new
    ].
    ^ newCommander
!

new:numberOfPens in:aDrawable
    |newCommander|
    newCommander := super new:numberOfPens.
    1 to:numberOfPens do:[ :index |
        newCommander at:index put:(Pen in:aDrawable)
    ].
    ^ newCommander
! !

!Commander methodsFor:'distributing'!

fanOut
    1 to:self size do:[:index |
        (self at:index) turn:(index - 1) * (360 / self size)
    ]
!

lineUpFrom:startPoint to:endPoint
    1 to:self size do:[:index |
        (self at:index)
            place:startPoint +
                  (endPoint - startPoint * (index - 1)/(self size - 1))
    ]
! !

!Commander methodsFor:'everything else'!

doesNotUnderstand:aMessage
    "this is funny: all message we do not understand, are passed
     on to every Pen - so we do not have to care for all
     possible messages ...(thanks to the Message class)"
    self do:[:each |
        each perform:(aMessage selector) withArguments:(aMessage args)
    ]
! !

!Commander methodsFor:'examples'!

example1
    self fanOut.
    self go:50.
    self spiral:60 angle:89
    "(Commander new:6) example1"
! !
