"
 COPYRIGHT (c) 1992 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DisplayObject subclass:#DisplayIcon
	 instanceVariableNames:'fileName picture icon'
	 classVariableNames:''
	 poolDictionaries:''
	 category:'Views-Document'
!

!DisplayIcon class methodsFor:'instance creation'!

forFile:aFileName
    ^ self new forFile:aFileName
! !

!DisplayIcon methodsFor:'private'!

forFile:aFileName
    |f baseName root|

    fileName := aFileName.
    f := aFileName.
    (f endsWith:'.c') ifTrue:[
        icon := Form fromFile:'C-File.48' resolution:100.
        icon notNil ifTrue:[^ self]
    ].
    (f endsWith:'.m') ifTrue:[
        icon := Form fromFile:'C-File.48' resolution:100.
        icon notNil ifTrue:[^ self]
    ].

    (f endsWith:'.vox') ifTrue:[
        f := 'voice.tiff'
    ].
    (f endsWith:'.VOX') ifTrue:[
        f := 'voice.tiff'
    ].
    (f endsWith:'.fax') ifTrue:[
        f := 'fax.tiff'
    ].
    (f endsWith:'.FAX') ifTrue:[
        f := 'fax.tiff'
    ].
    (f endsWith:'.wn') ifTrue:[
        f := 'wn.tiff'
    ].
    (f endsWith:'.WN') ifTrue:[
        f := 'wn.tiff'
    ].

    baseName := OperatingSystem baseNameOf:f.
    picture := Image fromFile:baseName.
    picture notNil ifTrue:[
        self recomputeFrame.
        ^ self
    ].
    icon isNil ifTrue:[
        icon := Form fromFile:baseName resolution:100.
        icon isNil ifTrue:[
            root := FileDirectory rootDirectory.
            (root isDirectory:f) ifTrue:[
                icon := Form fromFile:'DirObj.48' resolution:100
            ].
            icon isNil ifTrue:[
                (root isExecutable:f) ifTrue:[
                    icon := Form fromFile:'ExecObj.48' resolution:100
                ]
            ].
            icon isNil ifTrue:[
                icon := Form fromFile:'FileObj.48' resolution:100
            ]
        ]
    ].
    icon notNil ifTrue:[
        self recomputeFrame
    ].
    ^ self
!

recomputeFrame
    |origin extent w h|

    frame isNil ifTrue:[^ self].
    origin := frame origin.
    origin isNil ifTrue:[^ self].
    picture notNil ifTrue:[
        w := picture width.
        h := picture height
    ] ifFalse:[
        icon notNil ifTrue:[
            w := icon width.
            h := icon height
        ] ifFalse:[
            ^ self
        ]
    ].
    extent := w @ h.
    frame := Rectangle origin:origin extent:extent
! !

!DisplayIcon methodsFor:'accessing'!

origin:aPoint
    frame := Rectangle origin:aPoint corner:aPoint.
    self recomputeFrame
! !

!DisplayIcon methodsFor:'drawing'!

drawIn:aView offset:anOffset
    |xpos ypos origin offs device oldFg oldBg|

    device := aView device.

    picture notNil ifTrue:[
        icon notNil ifTrue:[
            (icon device ~~ device) ifTrue:[
                icon := nil
            ]
        ].
        icon isNil ifTrue:[
            icon := picture asFormOn:device
        ].
        icon notNil ifTrue:[
            offs := anOffset - aView viewOrigin.
            origin := frame origin.
            xpos := origin x + offs x.
            ypos := origin y + offs y.
            oldFg := aView foreground.
            oldBg := aView background.
            (picture photometric == #blackIs0) ifTrue:[
                aView foreground:(Color white) background:(Color black).
            ] ifFalse:[
                aView foreground:(Color black) background:(Color white).
            ].
            aView displayOpaqueForm:icon x:xpos y:ypos.
            aView foreground:oldFg background:oldBg.
        ].
        ^ self
    ].

    icon notNil ifTrue:[
        offs := anOffset - aView viewOrigin.
        origin := frame origin.
        xpos := origin x + offs x.
        ypos := origin y + offs y.
        aView displayOpaqueForm:icon x:xpos y:ypos
    ]
! !

!DisplayIcon methodsFor:'events'!

doubleClick
    "some icon has been doubleclicked on - open up a documentView for it"

    DocumentView startOn:fileName
! !

