"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DrawEllipse subclass:#DrawArc
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Applications-DrawTool-Objects'
!

DrawArc comment:'
COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

this class represents Arcs (i.e. parts of a circle)

$Header: /claus/smalltalk/st2.6/clients/DrawTool/RCS/DrawArc.st,v 1.2 94/01/13 00:41:50 claus Exp $
written summer 89 by claus
'!

!DrawArc methodsFor:'inside check'!

isHitBy:hitPoint withDelta:hitDelta

    |hx hy lw delta fullEllipse|

    "if its not on my full arc - forget it"

    fullEllipse := DEllipse new.
    fullEllipse

    lw := (lineWidth // 2) + 1.
    delta := hitDelta + lw.

    "quick boundary check"
    ((Rectangle origin:(origin x - delta)@(origin y - delta)
                corner:(corner x + delta)@(corner y + delta))
         containsPoint:hitPoint) ifFalse:[^ false].

    "if we have a fillpattern, we have a hit"
    fillPattern notNil ifTrue:[^ true].

    "otherwise, must check outline only"
    hx := hitPoint x.
    hy := hitPoint y.
    ((hx >= (origin x - delta)) and:[(hx <= (origin x + delta))])
        ifTrue:[
            ((hy >= (origin y - delta)) and:[
             (hy <= (corner y + delta))]) ifTrue:[^ true]
    ].
    ((hx >= (corner x - delta)) and:[(hx <= (corner x + delta))])
        ifTrue:[
            ((hy >= (origin y - delta)) and:[
             (hy <= (corner y + delta))]) ifTrue:[^ true]
    ].
    ((hy >= (origin y - delta)) and:[(hy <= (origin y + delta))])
        ifTrue:[
            ((hx >= (origin x - delta)) and:[
             (hx <= (corner x + delta))]) ifTrue:[^ true]
    ].
    ((hy >= (corner y - delta)) and:[(hy <= (corner y + delta))])
        ifTrue:[
            ((hx >= (origin x - delta)) and:[
             (hx <= (corner x + delta))]) ifTrue:[^ true]
    ].
    ^ false
! !

!DrawArc methodsFor:'drawing'!

"stc BUG !"
fillMasked:r in:aView
    aView withMask:fillPattern do:[
        aView fillRectangle:r
    ]
!

drawMasked:r in:aView
    aView withMask:linePattern do:[
        aView displayRectangle:r
    ]
!

drawIn:aView offset:anOffset
    |r|
    offs := anOffset - aView viewOrigin.
    r := Rectangle origin:(origin + offs) corner:(corner + offs).
    lineWidth notNil ifTrue:[
        (lineWidth == 1) ifTrue:[
            aView lineWidth:0
        ] ifFalse:[
            aView lineWidth:lineWidth
        ]
    ].
    aView withForeground:foreground do:[
        fillPattern notNil ifTrue:[
            self fillMasked:r in:aView
            "aView withMask:fillPattern do:[
                aView fillRectangle:r
            ]
            "
        ].
        linePattern notNil ifTrue:[
            self drawMasked:r in:aView
            "
            aView withMask:linePattern do:[
                aView displayRectangle:r
            ]
            "
       ]
    ].
    aView lineWidth:0
! !
