"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DrawObject subclass:#DrawEllipse
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Applications-DrawTool-Objects'
!

DrawEllipse comment:'

COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

this class represents ellipses (and circles)

$Header: /claus/smalltalk/st2.6/clients/DrawTool/RCS/DrawEll.st,v 1.2 93/12/16 11:40:43 claus Exp $
written summer 89 by claus
'!

!DrawEllipse class methodsFor:'DrawView interface'!

icon
    ^ Form fromFile:'DrawEll.xbm' resolution:100
! !

!DrawEllipse methodsFor:'inside check'!

isHitBy:hitPoint withDelta:hitDelta
    "return true, if circle/ellipse is hit by point"

    |cx cy a b lw delta
     aMin aMax bMin bMax
     aSquared bSquared
     aMinSquared aMaxSquared bMinSquared bMaxSquared
     px py xSquared ySquared x2PlusY2
     t1 t2|

    "quick boundary check"
    (super isHitBy:hitPoint withDelta:hitDelta) ifFalse:[^ false].

    lw := (lineWidth // 2) + 1.
    delta := hitDelta + lw.

    a := (corner x - origin x) // 2.
    b := (corner y - origin y) // 2.

    cx := origin x + a.
    cy := origin y + b.

    px := hitPoint x - cx.
    py := hitPoint y - cy.

    xSquared := px * px.
    ySquared := py * py.

    a == b ifTrue:[
        "its a circle"
        x2PlusY2 := xSquared + ySquared.
        fillPattern isNil ifTrue:[
            "outline check"
            aMin := a - delta.
            aMinSquared := aMin * aMin.
            x2PlusY2 < aMinSquared ifTrue:[^ false].
            aMax := a + delta.
            aMaxSquared := aMax * aMax.
            x2PlusY2 > aMaxSquared ifTrue:[^ false].
            ^ true
        ] ifFalse:[
            "area check"
            aSquared := a * a.
            x2PlusY2 <= aSquared ifTrue:[^ true]
        ].
        ^ false
    ].

    "an ellipse"
    fillPattern isNil ifTrue:[
        "outline check"
        "had to divide expression into smaller steps, since many
         c-compilers have problems compiling complicated exprs"
        aMin := a - delta.
        aMinSquared := aMin * aMin.
        bMin := b - delta.
        bMinSquared := bMin * bMin.
        t1 := (bMinSquared * xSquared) + (aMinSquared * ySquared).
        t2 := (aMinSquared * bMinSquared).
        t1 < t2 ifTrue:[^ false].
        aMax := a + delta.
        aMaxSquared := aMax * aMax.
        bMax := b + delta.
        bMaxSquared := bMax * bMax.
        t1 := (bMaxSquared * xSquared) + (aMaxSquared * ySquared).
        t2 := (aMaxSquared * bMaxSquared).
        t1 > t2 ifTrue:[^ false].
        ^ true
    ] ifFalse:[
        "area check"
        aSquared := a * a.
        bSquared := b * b.
        t1 := (bSquared * xSquared) + (aSquared * ySquared).
        t2 := (aSquared * bSquared).
        t1 <= t2 ifTrue:[^ true]
    ].
    ^ false
! !

!DrawEllipse methodsFor:'drawing'!

drawIn:aGC offset:anOffset
    |xpos ypos w h offs org|

    offs := anOffset - aGC viewOrigin.
    w := corner x - origin x "+ 1".
    h := corner y - origin y "+ 1".
    org := origin + offs.
    xpos := org x.
    ypos := org y.
    (lineWidth == 1) ifTrue:[
        aGC lineWidth:0
    ] ifFalse:[
        aGC lineWidth:lineWidth
    ].
    aGC setMaskOrigin:org.
    aGC paint:foreground on:background.

    fillPattern notNil ifTrue:[
        fillPattern == 1 ifTrue:[
            aGC fillArcX:xpos y:ypos w:w h:h from:0 angle:360
        ] ifFalse:[
            aGC withPattern:fillPattern do:[
                aGC fillArcX:xpos y:ypos w:w h:h from:0 angle:360
            ]
        ]
    ].

    linePattern notNil ifTrue:[
        linePattern == 1 ifTrue:[
            aGC displayArcX:xpos y:ypos w:w h:h from:0 angle:360
        ] ifFalse:[
            aGC withPattern:linePattern do:[
                aGC displayArcX:xpos y:ypos w:w h:h from:0 angle:360
            ]
        ]
    ].
    "leave gc in some known state"
    lineWidth > 1 ifTrue:[
        aGC lineWidth:0.
    ].
!

drawOutlineIn:aGC offset:anOffset
    |offs xpos ypos w h halfLw|

    "for slow servers, draw outline as a rectangle"
"
    super drawOutlineIn:aGC offset:anOffset.
    ^ self.
"

    offs := anOffset - aGC viewOrigin.
    w := corner x - origin x "+ 1".
    h := corner y - origin y "+ 1".
    xpos := origin x + offs x.
    ypos := origin y + offs y.
    lineWidth > 2 ifTrue:[
        "draw twice"
        halfLw := lineWidth // 2.
        aGC displayArcX:xpos-halfLw y:ypos-halfLw 
                        w:w+lineWidth h:h+lineWidth from:0 angle:360.
        aGC displayArcX:xpos+halfLw y:ypos+halfLw 
                        w:w-lineWidth h:h-lineWidth from:0 angle:360
    ] ifFalse:[
        aGC displayArcX:xpos y:ypos w:w h:h from:0 angle:360
    ]
! !
