"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DrawRectangle subclass:#DrawImage
       instanceVariableNames:'originalImage scaledImage'
       classVariableNames:''
       poolDictionaries:''
       category:'Applications-DrawTool-Objects'
!

DrawImage comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

I represent images

$Header: /claus/smalltalk/st2.6/clients/DrawTool/RCS/DrawImage.st,v 1.3 94/01/13 00:41:59 claus Exp $
written fall 93 by claus
'!

!DrawImage class methodsFor:'interface to DrawView'!

icon
    ^ Form fromFile:'DrawImage.xbm' resolution:100
! !

!DrawImage class methodsFor:'instance creation'!

new
    |i|

    i := super new.
    i setOrigin:0@0.
    ^ i
! !

!DrawImage methodsFor:'accessing'!

flipHorizontal
    originalImage flipHorizontal.
    scaledImage := nil
!

flipVertical
    originalImage flipVertical.
    scaledImage := nil
!

rotate:degrees
    |newImage oldOrigin|

    newImage := originalImage rotated:degrees.
    newImage notNil ifTrue:[
        oldOrigin := origin.
        self image:newImage.
        self origin:oldOrigin corner:(oldOrigin + newImage extent).
    ]
!

setOrigin:org
    origin := org
!

fillPattern
    "answer the fill pattern form, which is not really
     used, but needed to tell DrawView that images are filled
     objects"

    ^ Color black
!

image:anImage
   origin := 0@0.
   corner := anImage width @ anImage height.
   frame := origin corner:corner.
   originalImage := scaledImage := anImage
!

origin:newOrigin corner:newCorner
    "set new origin/corner; arguments given in pixels.
     This methhod is called both for moving and scaling,
     we have to check for a scale operation here."

    super origin:newOrigin corner:newCorner.
    scaledImage notNil ifTrue:[
        ((frame width ~= scaledImage width)
        or:[frame height ~= scaledImage height]) ifTrue:[
            scaledImage := nil
        ]
    ]
! !

!DrawImage methodsFor:'queries'!

isHitBy:aPoint withDelta:delta

    |org left right top bott px py d2|

    (delta == 0) ifTrue:[
        ^ frame containsPoint:aPoint
    ].

    "its quicker to not create a new rectangle for the test"
    org := frame origin.
    left := org x - delta.

    px := aPoint x.
    (px < left) ifTrue:[^ false].

    d2 := delta * 2.
    right := left + frame width + d2.
    (px > right) ifTrue:[^ false].

    top := org y - delta.
    py := aPoint y.
    (py < top) ifTrue:[^ false].

    bott := top + frame height + d2.
    (py > bott) ifTrue:[^ false].

    ^ true
! !


!DrawImage methodsFor:'private'!

scaleImage
    |r w h iw ih|

    w := frame width.
    h := frame height.
    iw := originalImage width.
    ih := originalImage height.
    ((w ~= iw) or:[h ~= ih]) ifTrue:[
        scaledImage := originalImage magnifyBy:(w / iw) @ (h / ih)
    ] ifFalse:[
        scaledImage := originalImage
    ]
! !

!DrawImage methodsFor:'drawing'!

drawIn:aView offset:anOffset
    |offs org corn w h wCorn hCorn top left c|

    offs := anOffset - aView viewOrigin.
    org := origin + offs.
    left := org x.
    top := org y.

"
    c := aView cursor.
    aView cursor:Cursor wait.
"
    scaledImage isNil ifTrue:[
        originalImage isNil ifTrue:[
            aView displayRectangle:self frame.
        ^ self
        ].
        aView showBusyWhile:[
            self scaleImage.
        ]
    ].

    scaledImage device ~~ aView device ifTrue:[
        aView showBusyWhile:[
            scaledImage := scaledImage on:aView device.
        ]
    ].
    aView foreground:Color black background:Color white.
    aView function:#copy.
    aView displayOpaqueForm:scaledImage x:left y:top.
"
    aView cursor:c
"
! !
