"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

DrawObject subclass:#DrawRectangle
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Applications-DrawTool-Objects'
!

DrawRectangle comment:'
COPYRIGHT (c) 1989-93 by Claus Gittinger
              All Rights Reserved

I represent rectangles

$Header: /claus/smalltalk/st2.6/clients/DrawTool/RCS/DrawRect.st,v 1.3 94/01/13 00:42:21 claus Exp $
written summer 89 by claus
'!

!DrawRectangle class methodsFor:'interface to DrawView'!

icon
    ^ Form fromFile:'DrawRect.xbm' resolution:100
! !

!DrawRectangle methodsFor:'testing'!

isHitBy:hitPoint withDelta:hitDelta
    "return true, if rectangle is hit by point"

    |lw delta top bottom left right dLeft dRight dTop dBot|

    (super isHitBy:hitPoint withDelta:hitDelta) ifFalse:[^ false].

    "if I have a fillpattern, we have a hit"
    fillPattern notNil ifTrue:[^ true].

    lw := (lineWidth // 2) + 1.
    delta := hitDelta + lw.

    "otherwise, check the 4 outlines"

    left := origin x.
    right := corner x.
    top := origin y.
    bottom := corner y.

    dLeft := left - delta.
    dRight := right + delta.
    dTop := top - delta.
    dBot := bottom + delta.

    "check area around top edge"
    ((Rectangle left:dLeft right:dRight
                 top:dTop bottom:(top + delta)) containsPoint:hitPoint)
        ifTrue:[^ true].

    "check area around bottom edge"
    ((Rectangle left:dLeft right:dRight
                 top:(bottom - delta) bottom:dBot) containsPoint:hitPoint)
        ifTrue:[^ true].

    "check area around left edge"
    ((Rectangle left:dLeft right:(left + delta)
                 top:dTop bottom:dBot) containsPoint:hitPoint)
        ifTrue:[^ true].

    "check area around right edge"
    ^ (Rectangle left:(right - delta) right:dRight
                  top:dTop bottom:dBot) containsPoint:hitPoint
! !

!DrawRectangle methodsFor:'drawing'!

drawIn:aGC offset:anOffset
    |offs r org|

    offs := anOffset - aGC viewOrigin.

    org := origin + offs.
    r := Rectangle origin:org corner:(corner + offs).
    (lineWidth == 1) ifTrue:[
        aGC lineWidth:0
    ] ifFalse:[
        aGC lineWidth:lineWidth
    ].

    aGC setMaskOrigin:org.

"
    aGC foreground:foreground background:background.
"
    aGC paint:foreground on:background.

    fillPattern notNil ifTrue:[
        fillPattern == 1 ifTrue:[
            aGC paint:foreground.
            aGC fillRectangle:r
        ] ifFalse:[
            aGC withPattern:fillPattern do:[
                aGC fillRectangle:r
            ]
        ]
    ].
    linePattern notNil ifTrue:[
        linePattern == 1 ifTrue:[
            aGC paint:foreground.
            aGC displayRectangle:r
        ] ifFalse:[
            aGC withPattern:linePattern do:[
                aGC displayRectangle:r
            ]
        ]
    ].
    "leave gc in some known state"
    lineWidth > 1 ifTrue:[
        aGC lineWidth:0.
    ].
! !
