GLXView subclass:#GLPlaneDemoView1 
         instanceVariableNames:'angle deltaT redrawBlock v1 v2 v3 v4'
         classVariableNames:''
         poolDictionaries:''
         category:'Views-3D'
!

GLPlaneDemoView1 comment:'
rotating plane - without double buffer.
corresponds to a demo (in c) found in examples

start with:
    GLPlaneDemoView1 start
'!

!GLPlaneDemoView1 methodsFor:'initialization'!

initialize
    super initialize.
    type := #colorIndexSingleBuffer.
    angle := 0.0.
    deltaT := 0.05.
    redrawBlock := [angle := angle + 3.0. self redraw].

    v1 := FloatArray withAll:#(-1.0 -1.0 0.0).
    v2 := FloatArray withAll:#( 1.0 -1.0 0.0).
    v3 := FloatArray withAll:#( 1.0  1.0 0.0).
    v4 := FloatArray withAll:#(-1.0  1.0 0.0).

    "GLPlaneDemoView1 new inspect"
!

unrealize 
    Processor removeTimedBlock:redrawBlock.
    super unrealize.
!

realize
    super realize.
    self perspectiveFovy:450 aspect:1.0 near:1.0 far:200.0. 
    self translateX:0 y:0 z:-150.

    Processor addTimedBlock:redrawBlock after:deltaT
! !

!GLPlaneDemoView1 methodsFor:'drawing'!

redraw 
    self color:Black.
    self clear.

    self pushMatrix.

    self rotateX:angle.
    self rotateY:angle+1.

    self scaleX:45 y:45 z:0.

    self color:Red.
    self beginPolygon.
    self v3f:v1.
    self v3f:v2.
    self v3f:v3.
    self v3f:v4.
    self endPolygon.

    self popMatrix.

    Processor addTimedBlock:redrawBlock after:deltaT
! !
