"
 COPYRIGHT (c) 1990 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Animation subclass:#GlobeDemo
       instanceVariableNames:'current globeIndex'
       classVariableNames:''
       poolDictionaries:''
       category:'Demos'
!

GlobeDemo comment:'
suns globes

$Header: /claus/smalltalk/st2.6/clients/Animation/RCS/GlobeDemo.st,v 1.1 93/10/25 10:42:49 claus Exp $
written spring 90 by claus
'!

!GlobeDemo class methodsFor:'startup'!

start
    |anim|

    Display initialize.
    anim := self
                extent:(256 @ 256)
                label:'Globe'
                icon:(Form fromFile:'Globe.icon' resolution:100)
                minExtent:(256 @ 256)
                maxExtent:(256 @ 256).

    anim realize.
    ^ anim

    "GlobeDemo start"
! !

!GlobeDemo methodsFor:'initialization'!

initialize
    super initialize.
    phase := 1.
    current := 0.
    delay := 0.1.
    globeIndex := 1
!

initForms
    |fileName form|

    forms isNil ifTrue:[
        forms := Array new:30.
        1 to:(forms size) do:[:i |
            fileName := 'globe' , (i printString) , '.xbm'.
            'reading ' print. fileName printNewline.
            form := Form fromFile:fileName.
            form isNil ifTrue:[
                self notify:('cannot read bitmap ', fileName).
                ^ self
            ].
            forms at:i put:form
        ]
    ]
! !

!GlobeDemo methodsFor:'drawing'!

drawGlobe:whichGlobe
    |form|
    form := forms at:whichGlobe.
    form notNil ifTrue:[
        self displayOpaqueForm:form x:0 y:0
    ].
    device synchronizeOutput
!

step
    globeIndex := globeIndex + phase.
    (globeIndex > (forms size)) ifTrue:[
        globeIndex := globeIndex - (forms size)
    ].
    self drawGlobe:globeIndex
!

redraw
    self drawGlobe:globeIndex
! !
