"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ThreeSliderPanel subclass:#HLSPanel
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Views-Interactors'
!

HLSPanel comment:'
 allows mixing of a color by hls values

HLSPanel new realize
 $Header: /claus/smalltalk/st2.6/clients/ColorPanel/RCS/HLSPanel.st,v 1.2 94/01/13 00:35:26 claus Exp $
 written june 93 by claus
'!

!HLSPanel class methodsFor:'specification'!

slider1Class
    ^ HueSlider
!

sliderClass
    ^ ColorSlider
! !

!HLSPanel methodsFor:'initialization'!

initialize
    super initialize.

    slider1 color:Color white; label:'hue'.
    slider2 color:Color white; label:'light'.
    slider3 inverseColor:Color white; label:'saturation'.

! !

!HLSPanel methodsFor:'user interaction'!

slider1:hueVal
    |h|

    h := (hueVal * 3.6) rounded.
    label1 label:(h printString).
    val1 := h.
    action value:val1 value:val2 value:val3
! !

!HLSPanel methodsFor:'accessing'!

setSlider1:hueVal slider2:lightVal slider3:satVal
    "hue is 0..360; slider wants 0..100"
    hueVal notNil ifTrue:[
        super setSlider1:hueVal / 3.6 slider2:lightVal slider3:satVal.
        label1 label:hueVal rounded printString
    ] ifFalse:[
        super setSlider1:hueVal slider2:lightVal slider3:satVal
    ]
!

setFrom:aColor
    self setSlider1:aColor hue 
            slider2:aColor light
            slider3:aColor saturation
!

saturationSlider
    ^ slider3
!

lightSlider
    ^ slider2
! !
