'From Smalltalk/X, Version:2.3.1 on 7-Sep-92 at 19:56:02'!

ScreenSaver subclass:#LightInTheDark 
         instanceVariableNames:'xpos ypos bigForm radius timedBlock2'
         classVariableNames:''
         poolDictionaries:''
         category:'Views-Demos'
!

LightInTheDark comment:'
start with:

    LightInTheDark start
'!

!LightInTheDark methodsFor:'initialization'!

initialize
    |cursor|

    radius := (device horizontalPixelPerMillimeter * 20) rounded.

    bigForm := Form width:device width 
                   height:device height 
                    depth:1
                       on:device.
    bigForm fill:(Color colorId:1).

    super initialize.

    timedBlock2 := [self evenCycle].
    timedBlock := [self oddCycle].
    self saveUnder:true.

    "LightInTheDark start"
! !

!LightInTheDark methodsFor:'cleanup'!

destroy
    Processor removeTimedBlock:timedBlock2.
    super destroy
! !

!LightInTheDark methodsFor:'private'!

fillHole
    xpos notNil ifTrue:[
        bigForm paint:(Color colorId:1).
        bigForm fillRectangleX:(xpos-radius-2) rounded y:(ypos-radius-2) rounded 
                         width:radius*2+4 height:radius*2+4.
    ]
!

punchHole
    bigForm paint:(Color colorId:0).
    bigForm fillCircleX:xpos rounded y:ypos rounded radius:radius.

    self borderShape:bigForm.
    self viewShape:bigForm.
    device synchronizeOutput.
!

evenCycle
    "show darkness"

    self fillHole.

    self borderShape:bigForm.
    self viewShape:bigForm.

    Processor addTimedBlock:timedBlock after:0.4
!

oddCycle
    "punch a hole at a random place"

    self fillHole.
    xpos := (random next * (device width - radius)) rounded asInteger.
    ypos := (random next * (device height - radius)) rounded asInteger.
    self punchHole.
    Processor addTimedBlock:timedBlock2 after:1 + (random nextBetween:1 and:3) 
! !
