"       NAME            Paths
        AUTHOR          scaletti@uxc.cso.uiuc.edu (Kurt J. Hebel)
        FUNCTION        Reimplementation of the Path hierarchy
        ST-VERSION      2.2?
        PREREQUISITES   
        CONFLICTS       
        DISTRIBUTION    world
        VERSION         1
        DATE    3 Jun 1987
"

Path subclass: #LinearFit
        instanceVariableNames: ''
        classVariableNames: ''
        poolDictionaries: ''
        category: 'Graphics-Paths'!
LinearFit comment:
'LinearFit defines a path that includes an arbitrary collection of points connected
 by lines.'!

!LinearFit methodsFor: 'displaying'!

displayOn: aDisplayMedium at: aPoint clippingBox: clipRect rule: anInteger mask:
 aForm
        "Display this LinearFit as a line connecting each pair of points in its collection
 of points.  Also, see comment in DisplayObject|displayOn:at:clippingBox:rule:mask:."

        | line |

        line _ Line new.
        line form: self form.

        collectionOfPoints inject: nil into: [ :lastPt :thisPt |
                lastPt ~~ nil ifTrue: [
                        line beginPoint: lastPt rounded truncated.
                        line endPoint: thisPt rounded truncated.
                        line
                                displayOn: aDisplayMedium
                                at: aPoint
                                clippingBox: clipRect
                                rule: anInteger
                                mask: aForm].
                        thisPt].! !


" The above file is a Manchester Goodie.  It is distributed freely on condition
 that you observe these conditions in respect of the whole Goodie, and on
 any significant part of it which is separately transmitted or stored:
        * You must ensure that every copy includes this notice, and that
          source and author(s) of the material are acknowledged.
        * These conditions must be imposed on anyone who receives a copy.
        * The material shall not be used for commercial gain without the prior
          written consent of the author(s).

 For more information about the Manchester Goodies Library (from which 
 this file was distributed) send e-mail:
        To: goodies-lib@cs.man.ac.uk
        Subject: help 
"!
