"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ExternalStream subclass:#NonPositionableExternalStream
       instanceVariableNames:'typeIfStandard'
       classVariableNames:''
       poolDictionaries:''
       category:'Streams-External'
!

NonPositionableExternalStream comment:'

COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

this one stands all non-positionable external streams; there are
terminal streams, pipe streams etc.

$Header: /claus/smalltalk/st2.6/libbasic/RCS/NPExtStr.st,v 1.6 94/01/16 03:43:13 claus Exp $
'!

%{
#include <stdio.h>
%}

!NonPositionableExternalStream class methodsFor:'instance creation'!

forStdin
    "return a NonPositionableExternalStream object for reading from
     Unixes standard input file descriptor"

    ^ self basicNew initializeForStdin
!

forStdout
    "return a NonPositionableExternalStream object for writing to
     Unixes standard output file descriptor"

    ^ self basicNew initializeForStdout
!

forStderr
    "return a NonPositionableExternalStream object for writing to
     Unixes standard error output file descriptor"

    ^ self basicNew initializeForStderr
! !

!NonPositionableExternalStream methodsFor:'private'!

initializeForStdin
    "setup for reading stdin"

    mode := #readonly.
    buffered := true.
    typeIfStandard := #Stdin.
%{
    _INST(filePointer) = MKOBJ(stdin);
%}
!

initializeForStdout
    "setup for writing to stdout"

    mode := #readwrite.
    buffered := false.
    typeIfStandard := #Stdout.
%{
    _INST(filePointer) = MKOBJ(stdout);
%}
!

initializeForStderr
    "setup for writing to stderr"

    mode := #readwrite.
    buffered := false.
    typeIfStandard := #Stderr.
%{
    _INST(filePointer) = MKOBJ(stderr);
%}
!

reOpen
    "reopen the stream after an image restart.
     If I am one of the standard streams, reopen is easy"

    (typeIfStandard == #Stdin) ifTrue:[
        ^ self initializeForStdin
    ].
    (typeIfStandard == #Stdout) ifTrue:[
        ^ self initializeForStdout
    ].
    (typeIfStandard == #Stderr) ifTrue:[
        ^ self initializeForStderr
    ].
    ^ super reOpen
! !

!NonPositionableExternalStream methodsFor:'redefind basic'!

size
    "report an error that this stream has no concept of size"

    self shouldNotImplement
!

position
    "report an error that this stream has no concept of position"

    self shouldNotImplement
!

position:anInteger
    "report an error that this stream has no concept of position"

    self shouldNotImplement
! !
