"
 COPYRIGHT (c) 1992 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Clock subclass:#RoundClock
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Demos'
!

RoundClock comment:'
 like Clock, but shows how arbitrary shaped windows are defined

 RoundClock start

 %W% %E%
 written summer 92 by claus
'!

!RoundClock methodsFor:'initialization'!

initialize
    super initialize.
    self label:'RoundClock'.
    self icon:(Form fromFile:'RClock.xbm' resolution:100).
    self computeShape

    "RoundClock start"
! !

!RoundClock methodsFor:'handling size changes'!

sizeChanged:how of:aView
    self computeShape.
    aView sizeChanged:how
! !

!RoundClock methodsFor:'shape computation'!

computeShape
    |extent shapeForm borderForm bw|

    extent := self extent.
    borderForm := Form width:(extent x) height:(extent y).
    borderForm fill:(Color colorId:0).
    shapeForm := Form width:(extent x) height:(extent y).
    shapeForm fill:(Color colorId:0).

    borderForm foreground:(Color colorId:1).
    borderForm fillArcX:0 y:0 
                      w:(borderForm width)
                      h:(borderForm height)
                   from:0
                  angle:360.
    bw := 3.
    shapeForm foreground:(Color colorId:1).
    shapeForm fillArcX:bw y:bw 
                     w:(shapeForm width - (bw * 2))
                     h:(shapeForm height - (bw * 2))
                   from:0
                  angle:360.
    self borderShape:borderForm.
    self viewShape:shapeForm
! !
