"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Button subclass:#ReturnButton
         instanceVariableNames:'arrowColor arrowShadowColor arrowLightColor noColor'
         classVariableNames:'returnArrowForm returnArrowLightForm returnArrowShadowForm'
         poolDictionaries:''
         category:'Views-Interactors'
!

ReturnButton comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

ReturnButtons show a return-arrow in addition to their
label. Used for quick-ok buttons in boxes.

$Header: /claus/smalltalk/st2.6/libwidg/RCS/RetButton.st,v 1.3 94/01/13 00:17:38 claus Exp $

written spring 93 by claus
'!

!ReturnButton class methodsFor:'defaults'!

returnArrowLightFormOn:aDisplay
    "answer the form used for the return arrow light area;
     cache the one for Display for the next round"

    |f|

    ((aDisplay == Display) and:[returnArrowLightForm notNil]) ifTrue:[
        ^ returnArrowLightForm
    ].
    f := Form fromFile:'ReturnLight.xbm' resolution:100 on:aDisplay.
    f isNil ifTrue:[
        f := Form width:24 height:16 fromArray:#(2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r00000000 2r00100000
                                                 2r00000000 2r11111111 2r11100000
                                                 2r00000000 2r10000000 2r00000000
                                                 2r00000000 2r10000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000)
                                              on:aDisplay
    ].
    (aDisplay == Display) ifTrue:[
        returnArrowLightForm := f
    ].
    ^ f
!

returnArrowFormOn:aDisplay
    "answer the form used for the return arrow light area;
     cache the one for Display for the next round"

    |f|

    ((aDisplay == Display) and:[returnArrowForm notNil]) ifTrue:[
        ^ returnArrowForm
    ].
    f := Form fromFile:'Return.xbm' resolution:100 on:aDisplay.
    f isNil ifTrue:[
        f := Form width:24 height:16 fromArray:#(2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000011 2r11100000
                                                 2r00000001 2r10000011 2r11100000
                                                 2r00000011 2r10000011 2r11100000
                                                 2r00000111 2r11111111 2r11100000
                                                 2r00001111 2r11111111 2r11100000
                                                 2r00011111 2r11111111 2r11100000
                                                 2r00001111 2r11111111 2r11100000
                                                 2r00000111 2r11111111 2r11100000
                                                 2r00000011 2r10000000 2r00000000
                                                 2r00000001 2r10000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000)
                                              on:aDisplay
    ].
    (aDisplay == Display) ifTrue:[
        returnArrowForm := f
    ].
    ^ f
!

returnArrowShadowFormOn:aDisplay
    "answer the form used for the return arrow light area;
     cache the one for Display for the next round"

    |f|

    ((aDisplay == Display) and:[returnArrowShadowForm notNil]) ifTrue:[
        ^ returnArrowShadowForm
    ].
    f := Form fromFile:'ReturnShadow.xbm' resolution:100 on:aDisplay.
    f isNil ifTrue:[
        f := Form width:24 height:16 fromArray:#(2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000011 2r11100000
                                                 2r00000001 2r10000010 2r00000000
                                                 2r00000010 2r10000010 2r00000000
                                                 2r00000100 2r11111110 2r00000000
                                                 2r00001000 2r00000000 2r00000000
                                                 2r00010000 2r00000000 2r00000000
                                                 2r00001000 2r00000000 2r00000000
                                                 2r00000100 2r00000000 2r00000000
                                                 2r00000010 2r00000000 2r00000000
                                                 2r00000001 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000
                                                 2r00000000 2r00000000 2r00000000)
                                              on:aDisplay
    ].
    (aDisplay == Display) ifTrue:[
        returnArrowShadowForm := f
    ].
    ^ f
! !

!ReturnButton methodsFor:'initialization'!

initStyle
    super initStyle.

    self is3D ifTrue:[
        shadowForm := self class returnArrowShadowFormOn:device.
        lightForm := self class returnArrowLightFormOn:device.
        arrowColor := viewBackground.
        arrowShadowColor := shadowColor.
        arrowLightColor := lightColor.
        noColor := Color noColor.
    ] ifFalse:[
        shadowForm := self class returnArrowFormOn:device.
        arrowColor := Black
    ]
! !

!ReturnButton methodsFor:'private'!

computeLabelSize
    "compute the extent needed to hold the label plus the return form"

    super computeLabelSize.
    labelWidth := labelWidth + hSpace + returnArrowForm width.
    labelHeight := labelHeight max: (returnArrowForm height + vSpace)
! !

!ReturnButton methodsFor:'redrawing'!

drawWith:fg and:bg
    "redraw myself with fg/bg. Use super to draw the label, add
     the return-arrow here."

    |x y|

    super drawWith:fg and:bg.   "this draws the text"

    y := (height - shadowForm height) // 2.
    x := width - shadowForm width - (hSpace // 2).

    self is3D ifFalse:[
        self paint:fg.
        self background:bg.
        self displayOpaqueForm:shadowForm x:x y:y
    ] ifTrue:[
        ((arrowShadowColor colorId notNil)
         and:[(arrowLightColor colorId notNil)
             and:[arrowColor colorId notNil]])
        ifTrue:[
            self foreground:arrowColor background:noColor function:#xor.
            self displayOpaqueForm:shadowForm x:x y:y.
            self foreground:arrowShadowColor function:#or.
            self displayOpaqueForm:shadowForm x:x y:y.
            self foreground:arrowColor function:#xor.
            self displayOpaqueForm:lightForm x:x y:y.
            self foreground:arrowLightColor function:#or.
            self displayOpaqueForm:lightForm x:x y:y.
        ]
    ]
! !
