"
 COPYRIGHT (c) 1991 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

LogicObject subclass:#SRFlipFlop
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Interface-LogicTool'
!

SRFlipFlop comment:'
 simple flip-flop

 $Header: /claus/smalltalk/st2.6/clients/LogicTool/RCS/SRFF.st,v 1.1 93/10/13 01:29:36 claus Exp $
 written summer 91 by claus
'!

!SRFlipFlop class methodsFor:'specification'!

icon
    icon isNil ifTrue:[
        icon := Form fromFile:(self iconFileName) resolution:100
    ].
    ^ icon
!

genericName
    ^ 'or'
!

numberOfOutputs
    ^ 1
! !

!SRFlipFlip methodsFor:'simulation'!

evaluate
    |inputNr n|
    inputNr := 1.
    n := self numberOfInputs.
    [inputNr <= n] whileTrue:[
	(inputValues at:inputNr) ifTrue: [
	    (outputValues at:1) ifFalse:[
		 changed := true
	    ].
	    outputValues at:1 put:true.
	    ^ true
	].
	inputNr := inputNr + 1
    ].
    (outputValues at:1) ifTrue:[
	 changed := true
    ].
    outputValues at:1 put:false.
    ^ false
! !
