'From Smalltalk/X, Version:2.6.4 on 4-Jun-1993 at 15:07:39'!

View subclass:#ScreenSaver
         instanceVariableNames:'keyboardForm timedBlock random prevX prevY'
         classVariableNames:''
         poolDictionaries:''
         category:'Views-Demos'
!

!ScreenSaver class methodsFor:'startup'!

start
    self new realize

    "ScreenSaver start"
! !

!ScreenSaver methodsFor:'initialization'!

initEvents
    super initEvents.
    self enableKeyEvents.
    self enableButtonMotionEvents.
    self enableMotionEvents.
    self enableButtonEvents.
    self saveUnder:true
!

initialize
    |cursor|

    super initialize.

    self borderWidth:0.
    self level:0.
    self viewBackground:Black.

    "a black cursor"
    self cursor:(Cursor extent:(16 @ 16)
                     fromArray:#(0 0 0 0 0 0 0 0
                                 0 0 0 0 0 0 0 0
                                 0 0 0 0 0 0 0 0
                                 0 0 0 0 0 0 0 0)
                        offset:(0 @ 0)).

    self origin:(0 @ 0)
         extent:(Display width) @ (Display height).

    keyboardForm := Form fromFile:'keyboard.xbm' resolution:100.
    timedBlock := [self cycle].
    Processor addTimedBlock:[self cycleAndCollectGarbage] after:0.5.
    random := Random new

    "ScreenSaver start"
! !

!ScreenSaver methodsFor:'events'!

mapped
    "get focus when visible"

    super mapped.
    device setInputFocusTo:drawableId.
!

buttonPress:button x:x y:y
    self destroy
!

keyPress:key x:x y:y
    self destroy
! !

!ScreenSaver methodsFor:'queries'!

createOnTop
    ^ true
! !

!ScreenSaver methodsFor:'private'!

cycle
    "show keyboard-form at a random place, trigger another cycle"

    |xpos ypos|

    keyboardForm notNil ifTrue:[
        prevX notNil ifTrue:[
            self paint:Black on:White.
            self fillRectangleX:prevX y:prevY
                          width:(keyboardForm width)
                         height:(keyboardForm height)
        ].

        xpos := (random next * (device width - keyboardForm width)) 
                                                            rounded asInteger.
        ypos := (random next * (device height - keyboardForm height))
                                                            rounded asInteger.
        self displayOpaqueForm:keyboardForm x:xpos y:ypos.
        prevX := xpos.
        prevY := ypos.
        timedBlock := [self cycle].
        Processor addTimedBlock:timedBlock after:2
    ]
!

cycleAndCollectGarbage
    "a good place to do a garbage collection ..."

    timedBlock value.
    ObjectMemory garbageCollect
! !

!ScreenSaver methodsFor:'cleanup'!

destroy
    |wDelta hDelta|

    Processor removeTimedBlock:timedBlock.
    super destroy
! !
