"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ListView subclass:#SelectionInListView
       instanceVariableNames:'selection actionBlock enabled
                              hilightFgColor hilightBgColor
                              halfIntensityFgColor
                              doubleClickActionBlock
                              selectConditionBlock
                              listAttributes multipleSelectOk clickLine
                              listSymbol initialSelectionSymbol printItems oneItem
                              hilightLevel hilightFrameColor ignoreReselect'
       classVariableNames:   'RightArrowShadowForm RightArrowLightForm RightArrowForm'
       poolDictionaries:''
       category:'Views-Text'
!

SelectionInListView comment:'

COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved
'!

!SelectionInListView class methodsFor:'documentation'!

documentation
"
this one is a ListView with a selected line (which is shown highlighted)
If multipleSelectionsOk is true, it is also allowed to shift-click multiple entries.

$Header: /claus/smalltalk/st2.6/libwidg/RCS/SelListV.st,v 1.7 94/01/13 00:18:21 claus Exp $

written spring/summer 89 by claus
3D Jan 90 by claus
multiselect Jun 92 my claus
"
! !

!SelectionInListView class methodsFor:'defaults'!

rightArrowLightFormOn:aDevice
    "return the form used for the right arrow light pixels (3D only)"

    |f|

    ((aDevice == Display) and:[RightArrowLightForm notNil]) ifTrue:[
        ^ RightArrowLightForm
    ].
    f := Form fromFile:'RightArrowLight.xbm' resolution:100 on:aDevice.
    f isNil ifTrue:[
        f := Form width:16 height:16 fromArray:#(2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000110 2r00000000 
                                                 2r00000101 2r00000000 
                                                 2r00000100 2r10000000 
                                                 2r00000100 2r01000000 
                                                 2r00000100 2r00100000 
                                                 2r00000100 2r00000000 
                                                 2r00000100 2r00000000
                                                 2r00000100 2r00000000 
                                                 2r00000100 2r00000000 
                                                 2r00000100 2r00000000
                                                 2r00000100 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000)
                                              on:aDevice
    ].
    (aDevice == Display) ifTrue:[
        RightArrowLightForm := f
    ].
    ^ f
!

rightArrowShadowFormOn:aDevice
    "return the form used for the right arrow light pixels (3D only)"

    |f|

    ((aDevice == Display) and:[RightArrowShadowForm notNil]) ifTrue:[
        ^ RightArrowShadowForm
    ].
    f := Form fromFile:'RightArrowShadow.xbm' resolution:100 on:aDevice.
    f isNil ifTrue:[
        f := Form width:16 height:16 fromArray:#(2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00010000 
                                                 2r00000000 2r00100000
                                                 2r00000000 2r01000000 
                                                 2r00000000 2r10000000 
                                                 2r00000001 2r00000000
                                                 2r00000010 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000)
                                              on:aDevice
    ].
    (aDevice == Display) ifTrue:[
        RightArrowShadowForm := f
    ].
    ^ f
!

rightArrowFormOn:aDevice
    "return the form used for the right arrow (non 3D)"

    |f|

    ((aDevice == Display) and:[RightArrowForm notNil]) ifTrue:[
        ^ RightArrowForm
    ].
    f := Form fromFile:'RightArrow.xbm' resolution:100 on:aDevice.
    f isNil ifTrue:[
        f := Form width:16 height:16 fromArray:#(2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000110 2r00000000 
                                                 2r00000101 2r00000000 
                                                 2r00000100 2r10000000 
                                                 2r00000100 2r01000000 
                                                 2r00000100 2r00100000 
                                                 2r00000100 2r00010000 
                                                 2r00000100 2r00100000
                                                 2r00000100 2r01000000 
                                                 2r00000100 2r10000000 
                                                 2r00000101 2r00000000
                                                 2r00000110 2r00000000 
                                                 2r00000000 2r00000000 
                                                 2r00000000 2r00000000)
                                              on:aDevice
    ].
    (aDevice == Display) ifTrue:[
        RightArrowForm := f
    ].
    ^ f
! !

!SelectionInListView class methodsFor:'instance creation'!

on:aModel printItems:print oneItem:one aspect:aspect
              change:change list:list menu:menu
                         initialSelection:initial

    "for ST-80 compatibility"

    ^ (self new) on:aModel printItems:print oneItem:one aspect:aspect
                               change:change list:list menu:menu
                     initialSelection:initial
! !

!SelectionInListView methodsFor:'initialization'!

initialize
    super initialize.

    fontHeight := font height + lineSpacing.
    multipleSelectOk := false.
    enabled := true.
    ignoreReselect := true.
!

initStyle
    super initStyle.

    bgColor := viewBackground.
    hilightFrameColor := nil.
    hilightLevel := 0.
    (style == #openwin) ifTrue:[
        lineSpacing := 3
    ] ifFalse:[
        lineSpacing := 2
    ].

    (style == #next) ifTrue:[
        device hasGreyscales ifTrue:[
            hilightFgColor := fgColor.
            hilightBgColor := White.
            hilightFrameColor := fgColor
        ] ifFalse:[
            hilightFgColor := White.
            hilightBgColor := Black
        ]
    ] ifFalse:[
        (style == #motif) ifTrue:[
            device hasGreyscales ifTrue:[
                hilightFgColor := fgColor.
                hilightBgColor := bgColor.
                hilightLevel := 2.
            ] ifFalse:[
                hilightFgColor := White.
                hilightBgColor := Black
            ]
        ] ifFalse:[
            (style == #openwin) ifTrue:[
                device hasGreyscales ifTrue:[
                    hilightFgColor := fgColor.
                    hilightBgColor := Color grey.
                    hilightLevel := -1.
                ] ifFalse:[
                    hilightFgColor := White.
                    hilightBgColor := Black
                ]
            ] ifFalse:[
                (style == #iris) ifTrue:[
                    device hasGreyscales ifTrue:[
                        hilightFgColor := bgColor.
                        hilightBgColor := Black
                    ] ifFalse:[
                        hilightFgColor := White.
                        hilightBgColor := Black
                    ]
                ] ifFalse:[
                    self is3D ifTrue:[
                        device hasColors ifTrue:[
                            hilightFgColor := Color name:'yellow'
                        ] ifFalse:[
                            hilightFgColor := White
                        ].
                        device hasGreyscales ifTrue:[
                            hilightBgColor := viewBackground
                        ] ifFalse:[
                            hilightBgColor := Black
                        ]
                    ]
                ]
            ]
        ]
    ].

    hilightFgColor isNil ifTrue:[
        hilightFgColor := bgColor.
        hilightBgColor := fgColor
    ].

    halfIntensityFgColor := Color darkGrey.
!

initCursor
    "set the cursor - a hand"

    cursor := Cursor hand
!

initEvents
    super initEvents.
    self enableButtonEvents
!

realize
    super realize.
    selection notNil ifTrue:[
        self makeLineVisible:selection
    ]
! !

!SelectionInListView methodsFor:'accessing'!

multipleSelectOk:aBoolean
    "allow/disallow multiple selections"

    multipleSelectOk := aBoolean.
    aBoolean ifTrue:[
        self enableButtonMotionEvents
    ] ifFalse:[
        self disableButtonMotionEvents
    ] 
!

ignoreReselect:aBoolean
    "set/clear the ignoreReselect flag - if set,
     a click on an already selected entry is ignored.
     Otherwise the notification is done, even if no
     change in the selection occurs."

    ignoreReselect := aBoolean
!

setList:aCollection
    "set the list - redefined, since setting the list implies unselecting"

    selection := nil.
    super setList:aCollection
!

list:aCollection
    "set the list - redefined, since setting the list implies unselecting"

    "somewhat of a kludge: if selection is first line,
     we have to remove the highlight frame by hand here"

    (shown and:[hilightLevel ~~ 0]) ifTrue:[
        selection == firstLineShown ifTrue:[
           self paint:bgColor.
           self fillRectangleX:margin y:margin
                          width:(width - (margin * 2)) 
                         height:(hilightLevel abs).
        ].
    ].

    selection := nil.
    super list:aCollection
!

attributes:aList
    "set the attribute list"

    listAttributes := attributes
!

attributeAt:index
    "return the line attribute of list line index"

    listAttributes isNil ifFalse:[
        (index > listAttributes size) ifFalse:[
            ^ listAttributes at:index
        ]
    ].
    ^ nil
!

attributeAt:index put:aSymbol
    "set a line attribute; currently attributes are:
     #halfIntensity
    "

    (index > list size) ifFalse:[
        listAttributes isNil ifTrue:[
            listAttributes := VariableArray new:index
        ] ifFalse:[
            (index > listAttributes size) ifTrue:[
                listAttributes grow:index
            ]
        ].
        aSymbol == (listAttributes at:index) ifFalse:[
            listAttributes at:index put:aSymbol.
            self redrawLine:index
        ]
    ]
!

removeIndexWithoutRedraw:lineNr
    "delete line - no redraw;
     return true, if something was really deleted.
     Redefined since we have to care for selection"

    self checkRemovingSelection:lineNr.
    ^ super removeIndexWithoutRedraw:lineNr
!

removeIndex:lineNr
    "delete line - with redraw.
     Redefined since we have to care for selection"

    self checkRemovingSelection:lineNr.
    ^ super removeIndex:lineNr
!

action:aBlock
    "set the action block to be performed on select"

    actionBlock := aBlock
!

doubleClickAction:aBlock
    "set the double click action block to be performed on select"

    doubleClickActionBlock := aBlock
!

selectConditionBlock:aBlock
    "set the conditionBlock; this block is evaluated before a selection
     change is performed; the change will not be done, if the evaluation
     returns false. For example, this allows confirmation queries in
     the SystemBrowser"

    selectConditionBlock := aBlock
!

numberOfSelections
    "return the number of selected entries"

    |sz|

    selection isNil ifTrue:[^ 0].
    sz := selection size.
    sz > 0 ifTrue:[^ sz].
    ^ 1
!

selectionValue
    "return the selection value i.e. the text in the selected line.
     For multiple selections a collection containing the entries is returned."

    selection isNil ifTrue:[^ nil].
    (selection isKindOf:Collection) ifTrue:[
        ^ selection collect:[:nr | list at:nr]
    ].
    ^ list at:selection
!

selection
    "return the selection line nr or collection of line numbers"

    ^ selection
!

deselect
    "deselect"

    self selection:nil
!

deselectWithoutRedraw
    "deselect - no redraw"

    selection := nil
!

enable
    "enable selections"

    enabled := true
!

disable
    "disable selections"

    enabled := false
!

selectElement:anObject
    "select the element with same printString as the argument, anObject"

    |lineNo|

    list notNil ifTrue:[
        lineNo := list indexOf:(anObject printString) ifAbsent:[^ self].
        self selection:lineNo
    ]
!

selectWithoutScroll:aNumberOrNil
    "select line, aNumber or deselect if argument is nil"

    |prevSelection newSelection|

    newSelection := aNumberOrNil.
    newSelection notNil ifTrue:[
        (self isValidSelection:newSelection) ifFalse:[
            newSelection := nil
        ]
    ].

    (newSelection == selection) ifTrue: [^ self].

    selection notNil ifTrue: [
        prevSelection := selection.
        selection := nil.
        (prevSelection isKindOf:Collection) ifTrue:[
            prevSelection do:[:line |
                self redrawElement:line
            ]
        ] ifFalse:[
            self redrawElement:prevSelection
        ]
    ].
    selection := newSelection.
    selection notNil ifTrue:[
        self redrawElement:selection
    ]
!

selection:aNumberOrNil
    "select line, aNumber or deselect if argument is nil;
     make the line visible"

    self selectWithoutScroll:aNumberOrNil.
    selection notNil ifTrue:[
        shown ifTrue:[
            self makeLineVisible:selection
        ]
    ]
!

addElementToSelection:anObject
    "add the element with the same printstring as the argument, anObject
     to the selection"

    |lineNo|
    lineNo := list indexOf:(anObject printString) ifAbsent:[^ self].
    self addToSelection:lineNo
!

addToSelection:aNumber
    "add line, aNumber to the selection"

    selection isNil ifTrue:[^ self selectWithoutScroll:aNumber].

    (self isValidSelection:aNumber) ifFalse:[^ self].
    (selection isKindOf:Collection) ifTrue:[
        (selection includes:aNumber) ifTrue:[^ self].
        selection add:aNumber
    ] ifFalse:[
        (aNumber == selection) ifTrue:[^ self].
        selection := OrderedCollection with:selection with:aNumber
    ].
    self redrawElement:aNumber
!

selectNext
    "select next line or first if there is currrently no selection"

    selection isNil ifTrue:[
        self selection:1
    ] ifFalse:[
        self selection:(selection + 1).
        selection isNil ifTrue:[
            self selection:1
        ]
    ]
!

selectPrevious
    "select previous line or last if there is currently no selection"

    selection isNil ifTrue:[
        self selection:(list size)
    ] ifFalse:[
        self selection:(selection - 1).
        selection isNil ifTrue:[
            self selection:(list size)
        ]
    ]
!

on:aModel printItems:print oneItem:one aspect:aspect
              change:change list:list menu:menu
    initialSelection:initial

    "ST-80 compatibility"

    aspectSymbol := aspect.
    changeSymbol := change.
    listSymbol := list.
    menuSymbol := menu.
    initialSelectionSymbol := initial.
    printItems := print.
    oneItem := one.

    model := aModel.

    listSymbol notNil ifTrue:[
        self list:(aModel perform:listSymbol) asText
    ].
    model addDependent:self
! !

!SelectionInListView methodsFor:'private'!

checkRemovingSelection:lineNr
    "when a line is removed, we have to adjust selection"

    |newSelection|

    selection notNil ifTrue:[
        (selection isKindOf:Collection) ifTrue:[
            newSelection := OrderedCollection new.
            selection do:[:sel |
                sel < lineNr ifTrue:[
                    newSelection add:sel
                ] ifFalse:[
                    sel > lineNr ifTrue:[
                        newSelection add:(sel - 1)
                    ]
                ]
            ].
            newSelection size == 1 ifTrue:[
                selection := newSelection first
            ] ifFalse:[
                newSelection size == 0 ifTrue:[
                    selection := nil
                ] ifFalse:[
                    selection := newSelection
                ]
            ]
        ] ifFalse:[
            selection == lineNr ifTrue:[
                selection := nil
            ] ifFalse:[
                selection > lineNr ifTrue:[
                    selection := selection - 1
                ]
            ]
        ]
    ]
!

isValidSelection:aNumber
    "return true, if aNumber is ok for a selection lineNo"

    aNumber isNil ifTrue:[^ false].
    ^ (aNumber between:1 and:list size)
!

isInSelection:aNumber
    "return true, if line, aNumber is in the selection"

    selection isNil ifTrue:[^ false].
    (selection isKindOf:Collection) ifTrue:[
        ^ (selection includes:aNumber)
    ].
    ^ (aNumber == selection)
!

positionToSelectionX:x y:y
    "given a click position, return the selection lineNo"

    |visibleLine|

    (x between:0 and:width) ifTrue:[
        (y between:0 and:height) ifTrue:[
            visibleLine := self visibleLineOfY:y.
            ^ self visibleLineToListLine:visibleLine
        ]
    ].
    ^ nil
!

widthForScrollBetween:start and:end
    "has to be redefined since WHOLE line is inverted/modified sometimes"

    | anySelectionInRange |

    selection notNil ifTrue:[
        (selection isKindOf:Collection) ifTrue:[
            anySelectionInRange := false.
            selection do:[:s |
                (s between:start and:end) ifTrue:[
                    anySelectionInRange := true
                ]
            ]
        ] ifFalse:[
            anySelectionInRange := selection between:start and:end
        ]
    ] ifFalse:[
        anySelectionInRange := false
    ].

    anySelectionInRange ifTrue:[
        self is3D ifFalse:[
            ^ width 
        ].
        ( #(next openwin) includes:style) ifTrue:[
            ^ width 
        ].
        viewBackground = background ifFalse:[
            ^ width 
        ]
    ].
    ^ super widthForScrollBetween:start and:end
!

visibleLineNeedsSpecialCare:visLineNr
    |listLine|

    listLine := self visibleLineToListLine:visLineNr.
    listLine isNil ifTrue:[^ false].
    (self isInSelection:listLine) ifTrue:[^ true].
    listAttributes notNil ifTrue:[
        (listLine <= listAttributes size) ifTrue:[
            ^ (listAttributes at:listLine) notNil
        ]
    ].
    ^ false
!

removeFromSelection:aNumber
    "remove line, aNumber from the selection"

    selection isNil ifTrue:[^ self].

    (selection isKindOf:Collection) ifTrue:[
        (selection includes:aNumber) ifFalse:[^ self].
        selection remove:aNumber.
        (selection size == 1) ifTrue:[
            selection := selection at:1
        ]
    ] ifFalse:[
        (aNumber == selection) ifFalse:[^ self].
        selection := nil
    ].
    self redrawElement:aNumber
!

scrollSelectDown
    "auto scroll action; scroll and reinstall timed-block"

    Processor addTimedBlock:autoScrollBlock after:autoScrollDeltaT.
    self scrollDown
!

scrollSelectUp
    "auto scroll action; scroll and reinstall timed-block"

    Processor addTimedBlock:autoScrollBlock after:autoScrollDeltaT.
    self scrollUp
! !

!SelectionInListView methodsFor:'redrawing'!

drawRightArrowInVisibleLine:visLineNr
    "draw a right arrow (for submenus).
     This method is not used here, but provided for subclasses such
     as menus or file-lists."

    |w h y x l form|

    x := width - 16.
    y := (self yOfLine:visLineNr).

    device depth == 1 ifTrue:[
        form := self class rightArrowFormOn:device.
        y := y + ((font height - form height) // 2).
        self foreground:Black.
        self displayForm:form x:x y:y.
    ] ifFalse:[
        form := self class rightArrowLightFormOn:device.
        y := y + ((font height - form height) // 2).

        self foreground:lightColor.
        self displayForm:form x:x y:y.

        self foreground:shadowColor.
        self displayForm:(self class rightArrowShadowFormOn:device) x:x y:y.
    ]
!

redrawElement:aNumber
    "redraw an individual element"

    ^ self redrawLine:aNumber
!

redrawVisibleLine:visLineNr col:colNr
    (self visibleLineNeedsSpecialCare:visLineNr) ifTrue:[
        ^ self redrawVisibleLine:visLineNr
    ].
    super redrawVisibleLine:visLineNr col:colNr
!

redrawVisibleLine:visLineNr from:startCol
    (self visibleLineNeedsSpecialCare:visLineNr) ifTrue:[
        ^ self redrawVisibleLine:visLineNr
    ].
    super redrawVisibleLine:visLineNr from:startCol
!

redrawVisibleLine:visLineNr from:startCol to:endCol
    (self visibleLineNeedsSpecialCare:visLineNr) ifTrue:[
        ^ self redrawVisibleLine:visLineNr
    ].
    super redrawVisibleLine:visLineNr from:startCol to:endCol
!

redrawFromVisibleLine:startVisLineNr to:endVisLineNr
    |special sel
     selNo "{ Class: SmallInteger }" |

    ((selection isKindOf:Collection) or:[listAttributes notNil]) ifTrue:[
        startVisLineNr to:endVisLineNr do:[:visLine |
            self redrawVisibleLine:visLine
        ].
        ^ self
    ].

    special := true.
    selection isNil ifTrue:[
        special := false
    ] ifFalse:[
        sel := self listLineToVisibleLine:selection.
        sel isNil ifTrue:[
            special := false
        ] ifFalse:[
            special := (sel between:startVisLineNr and:endVisLineNr)
        ]
    ].
    special ifFalse:[
      ^ super redrawFromVisibleLine:startVisLineNr
                                 to:endVisLineNr
    ].

    selNo := sel.
    selNo > startVisLineNr ifTrue:[
        super redrawFromVisibleLine:startVisLineNr to:(selNo - 1)
    ].
    self redrawVisibleLine:selNo.
    selNo < endVisLineNr ifTrue:[
        super redrawFromVisibleLine:(selNo + 1) to:endVisLineNr
    ]
!

redrawVisibleLine:visLineNr
    |listLine fg bg
     y "{ Class: SmallInteger }" |

    fg := fgColor.
    bg := bgColor.
    listLine := self visibleLineToListLine:visLineNr.
    listLine notNil ifTrue:[
        (self attributeAt:listLine) == #halfIntensity ifTrue:[
            fg := halfIntensityFgColor
        ].
        (self isInSelection:listLine) ifTrue:[
            bg := hilightBgColor.
            fg := hilightFgColor.
            hilightFrameColor notNil ifTrue:[
                self drawVisibleLine:visLineNr with:fg and:bg.
                y := self yOfLine:visLineNr.
                self paint:hilightFrameColor.
                self displayLineFromX:0 y:y toX:width y:y.
                y := y + fontHeight - 1.
                self displayLineFromX:0 y:y toX:width y:y.
                ^ self
            ].
            (hilightLevel ~~ 0) ifTrue:[
                self drawVisibleLine:visLineNr with:fg and:bg.
                y := self yOfLine:visLineNr.
                self drawEdgesForX:0 y:y 
                             width:width height:fontHeight 
                             level:hilightLevel.
                ^ self
            ]
        ]
    ].
    ^ self drawVisibleLine:visLineNr with:fg and:bg
! !

!SelectionInListView methodsFor:'event handling'!

sizeChanged:how
    "if there is a selection, make certain, its visible
     after the sizechange"

    |first|

    super sizeChanged:how.
    shown ifTrue:[
        selection notNil ifTrue:[
            (selection isKindOf:Collection) ifTrue:[
                first := selection first
            ] ifFalse:[
                first := selection
            ].
            self makeLineVisible:first
        ]
    ]
!

keyPress:key x:x y:y
    "handle keyboard input"

    (keyboardHandler notNil
    and:[keyboardHandler canHandle:key]) ifTrue:[
        keyboardHandler keyPress:key x:x y:y.
        ^ self
    ].
    (selection isKindOf:Collection) ifFalse:[
        (key == #CursorUp)        ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                self selectPrevious.
                actionBlock notNil ifTrue:[actionBlock value:selection].
            ].
            ^ self
        ].
        (key == #CursorDown)      ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                self selectNext.
                actionBlock notNil ifTrue:[actionBlock value:selection].
            ].
            ^ self
        ].
        (key == #Home)      ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                self selection:1. 
                actionBlock notNil ifTrue:[actionBlock value:selection].
            ].
            ^ self
        ].
        (key == #End)       ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                self selection:list size. 
                actionBlock notNil ifTrue:[actionBlock value:selection].
            ].
            ^ self
        ].
    ].
    ^ super keyPress:key x:x y:y
!

buttonPress:button x:x y:y
    |oldSelection listLineNr|

    (button == 1) ifTrue:[
        enabled ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                oldSelection := selection.
                listLineNr := self visibleLineToListLine:(self visibleLineOfY:y).
                listLineNr notNil ifTrue: [
                    self selectWithoutScroll:listLineNr
                ].
                ((ignoreReselect not and:[selection notNil])
                 or:[selection ~= oldSelection]) ifTrue:[
                    actionBlock notNil ifTrue:[actionBlock value:selection].
                    "the ST-80 way of doing things"
                    model notNil ifTrue:[
                        model perform:changeSymbol with:(self selectionValue)
                    ]
                ].
                clickLine := listLineNr
            ]
        ]
    ] ifFalse:[
        super buttonPress:button x:x y:y
    ]
!

buttonShiftPress:button x:x y:y
    |oldSelection listLineNr|

    (button == 1) ifTrue:[
        enabled ifTrue:[
            (selectConditionBlock isNil or:[selectConditionBlock value]) ifTrue:[
                oldSelection := selection copy.
                listLineNr := self visibleLineToListLine:(self visibleLineOfY:y).
                listLineNr notNil ifTrue: [
                    multipleSelectOk ifTrue:[
                        (self isInSelection:listLineNr) ifTrue:[
                            self removeFromSelection:listLineNr
                        ] ifFalse:[
                            self addToSelection:listLineNr
                        ]
                    ] ifFalse:[
                        self selectWithoutScroll:listLineNr
                    ]
                ].
                (selection ~= oldSelection) ifTrue:[
                    actionBlock notNil ifTrue:[actionBlock value:selection].
                    "the ST-80 way of doing things"
                    model notNil ifTrue:[model perform:changeSymbol with:(self selectionValue)]
                ].
                clickLine := listLineNr
            ]
        ]
    ] ifFalse:[
        super buttonShiftPress:button x:x y:y
    ]
!

buttonMultiPress:button x:x y:y
    (button == 1) ifTrue:[
        doubleClickActionBlock isNil ifTrue:[
            self buttonPress:button x:x y:y
        ] ifFalse:[
            doubleClickActionBlock value:selection
        ]
    ] ifFalse:[
        super buttonMultiPress:button x:x y:y
    ]
!

buttonRelease:button x:x y:y
    "stop any autoscroll"

    self stopAutoScroll
!

buttonMotion:button x:x y:y
    "mouse-move while button was pressed - handle selection changes"

    |movedVisibleLine movedLine delta oldSelection oldSelCount|

    clickLine isNil ifTrue:[^ self].

    "if moved outside of view, start autoscroll"
    (y < 0) ifTrue:[
        self compressMotionEvents:false.
        self startScrollUp:y.
        ^ self
    ].
    (y > height) ifTrue:[
        self compressMotionEvents:false.
        self startScrollDown:(y - height).
        ^ self
    ].

    "move inside - stop autoscroll if any"
    self stopAutoScroll.

    movedVisibleLine := self visibleLineOfY:y.
    movedLine := self visibleLineToAbsoluteLine:movedVisibleLine.
    (movedLine == clickLine) ifTrue:[^ self].

    multipleSelectOk ifTrue:[
        delta := (clickLine < movedLine) ifTrue:[1] ifFalse:[-1].

        oldSelection := selection.
        oldSelCount := selection size.

        (clickLine+delta) to:movedLine by:delta do:[:line |
            (self isInSelection:line) ifTrue:[
                self removeFromSelection:line
            ] ifFalse:[
                self addToSelection:line
            ]
        ].
        ((selection ~= oldSelection)
         or:[selection size ~~ oldSelCount]) ifTrue:[
            actionBlock notNil ifTrue:[actionBlock value:selection]
        ]
    ] ifFalse:[
        self selectWithoutScroll:movedLine
    ].

    clickLine := movedLine
!

update:aParameter
    |newList|

    (aParameter == initialSelectionSymbol) ifTrue:[
        self selectElement:(model perform:initialSelectionSymbol).
        ^ self
    ].
    (aParameter == listSymbol) ifTrue:[
        newList := (model perform:listSymbol) asText.
        (newList = list) ifFalse:[
            self list:newList
        ]
    ]
! !
