TreeView subclass:#TreeGraphView
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'Demos-Graphics'
!

TreeGraphView comment:'
 a better implementation of TreeView - this one looks
 pretty nice ...
 another application showing an ObjectView use

 start with:
     TreeGraphView start

 %W% %E%
 written Sep 92 by claus
'!

!TreeGraphView methodsFor:'generating the class-tree picture'!

addChildrenToTreeFrom:anElement xPos:xPos yPos:yPos
    self addChildrenToTreeFrom:anElement father:nil xPos:xPos yPos:yPos first:true
!

addChildrenToTreeFrom:anElement father:father xPos:xPos yPos:yPos first:isFirst
    |newObject yNext subX subFirst anyChildren|

    newObject := self addElementToTree:anElement xPos:xPos yPos:yPos.
    father notNil ifTrue:[
        self addLineFrom:father to:newObject
    ].

    subX := xPos + newObject frame width + xIndent.
    yNext := yPos.

    subFirst := true.
    anyChildren := false.
    self childrenOf:anElement do:[:aChild |
        yNext := self addChildrenToTreeFrom:aChild
                                     father:newObject
                                       xPos:subX
                                       yPos:yNext
                                      first:subFirst.
        subFirst := false.
        anyChildren := true.
    ].
    anyChildren ifFalse:[
        yNext := yPos + newObject frame height + 8
    ].
    ^ yNext
!

addElementToTree:anElement xPos:xPos yPos:yPos
    |newObject rect color|

    color := self colorFor:anElement.

    newObject := DrawText new.
    newObject text:(self textFor:anElement).
    newObject origin:(xPos @ yPos).
    newObject foreground:color background:White.
    newObject fillPattern:1.
    assoc at:newObject put:anElement.
    self add:newObject.

    rect := DrawRectangle new.
    rect origin:(newObject origin - (2 @ 2)) corner:(newObject corner + (2 @ 2)).
    rect foreground:color background:White.
    self add:rect.

    maxX := maxX max:(rect corner x).
    maxY := maxY max:(rect corner y).

    ^ newObject
!

addLineFrom:superObject to:object
    |x1 y1 x2 y2 xh newObject|

    x1 := superObject frame right + 2.
    y1 := (superObject frame top) + (superObject frame height // 2).
    x2 := object frame left - 2.
    y2 := (object frame top) + (object frame height // 2).
    xh := x1 + ((x2 - x1) // 2).

    newObject := DrawLine new.
    newObject origin:(x1 @ y1) corner:(xh @ y1).
    newObject foreground:Black background:White.
    self add:newObject.

    newObject := DrawLine new.
    newObject origin:(xh @ y1) corner:(xh @ y2).
    newObject foreground:Black background:White.
    self add:newObject.

    newObject := DrawLine new.
    newObject origin:(xh @ y2) corner:(x2 @ y2).
    newObject foreground:Black background:White.
    self add:newObject
! !

!TreeGraphView methodsFor:'user interaction'!

select:anObject
    "dont allow selection of line-elements"

    (anObject isKindOf:DrawText) ifTrue:[
        super select:anObject
    ]
! !
