"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

ByteArray subclass:#UninterpretedBytes
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'System-Support'
!

UninterpretedBytes comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

$Header: /claus/smalltalk/st2.6/libbasic/RCS/UIBytes.st,v 1.4 94/02/25 13:06:59 claus Exp $
'!

!UninterpretedBytes class methodsFor:'documentation'!

documentation
"
    this class has been added for ST-80 compatibility.
    Notice, that in SY/X all functionality is inherited from 
    ByteArray - have a look at this for more.
"
! !

!UninterpretedBytes class methodsFor:'queries'!

isBigEndian
    "from what the testers told me, this method seems to return 
     the wrong value in ST-80.
     (in my understanding: LSB == least-first == most-last == bigEndian)
     To be compatible, ST/X does it too :-(

     Better do not use it, until this has been clearified; 
     in ST/X, use isLSBfirst, which will stay as it is."

    ^ self isLSB not

    "UninterpretedBytes isBigEndian"
!

isLSBfirst
    "return true, if words/shorts store the least-significant
     byte first (LSB), false if most-sign.-first (MSB). 
     I.e. true for vax, intel; false for m68k, sun."

%{  /* NOCONTEXT */

    /*
     * I dont like ifdefs - you always forget some ...
     * therefore we look into a structure at run-time
     */
    union {
        unsigned int   u_l;
        char           u_c[sizeof(int)];
    } u;

    u.u_l = 0x87654321;
    if (u.u_c[0] == 0x21) RETURN (true);
    RETURN (false );
%}
    "UninterpretedBytes isLSBfirst"
! !
