'From Smalltalk/X, Version:2.6.3 on 25-Mar-1993 at 16:32:18'!

FileBrowser subclass:#VocBrowser
         instanceVariableNames:''
         classVariableNames:''
         poolDictionaries:''
         category:'Applications-Sound'
!

VocBrowser comment:'
a demo application for sound blaster voice files (.voc),
NeXT sound files (.snd) and sun sound files (.au).
Currently, it can display and play 8bit mono sounds only.
'!

!VocBrowser class methodsFor:'instance creation'!

new
    ^ super
        label:'Voice File Browser'
        icon:(Form fromFile:'VBrowser.icn' resolution:100)
        minExtent:(100 @ 100)
!

start
    ^ self new realize

    "VocBrowser start"
! !

!VocBrowser methodsFor:'user interaction'!

showFile:fileName
    "show contents of fileName in subView"

    ((currentDirectory typeOf:fileName) == #regular) ifTrue:[
        subView contentsFromFile:fileName in:currentDirectory
    ]
!

fileGetInfoString:longInfo
    "redefined to handle sound info"

    |string fileName fullPath text info stream fileOutput type modeBits modeString s|

    string := super fileGetInfoString:longInfo.
    string isNil ifTrue:[^ nil].

    "look if its a sound file"
    ^ string
!

filePlay
    "play data on sound-device"

    |fileName outStream inStream buffer count|

    fileName := self getSelectedFileName.
    fileName notNil ifTrue:[
        inStream := FileStream readonlyFileNamed:fileName 
                                              in:currentDirectory.
        inStream notNil ifTrue:[
            outStream := SoundStream writing.
            outStream isNil ifTrue:[
                self showAlert:'cannot open sound device'.
                inStream close.
                ^ self
            ].
            self withCursor:Cursor wait do:[
                buffer := ByteArray new:8192.
                count := inStream nextBytes:8192 into:buffer.
                [count > 0] whileTrue:[
                    outStream nextPutBytes:count from:buffer.
                    count := inStream nextBytes:8192 into:buffer
                ].
                outStream close.
                inStream close
            ]
        ]
    ]
!

fileRecord
    "record data from sound-device"

    self warn:'not yet implemented'

! !

!VocBrowser methodsFor:'private'!

showEmpty
    "clear subView"

    subView contents:nil
!

showInfo:info
    "redefined, sound view cannot show text"
! !

!VocBrowser methodsFor:'initialization'!

initializeSubViewIn:frame
    ^ HVScrollableView for:VocView in:frame
!

initializeFileListMiddleButtonMenu
    |labels|

    fileListView  notNil ifTrue:[
        labels := (self class classResources)
	 	     array:#(
                        'get'
                        'show info'             
                        'show full info'          
                        '-'
                        'play'
                        'recurs'
                        '-'
                        'change directory'       
                        '-'
                        'update'             
                        '-'
                        'delete'                 
                        'rename'                
                        '-'
                        'make directory'        
                        'make file').
        fileListView
            middleButtonMenu:(PopUpMenu 
                                    labels:labels
                                 selectors:#(fileGet
                                             fileGetInfo
                                             fileGetLongInfo
                                             nil
                                             filePlay
                                             fileRecord
                                             nil
                                             changeCurrentDirectory
                                             nil
                                             updateCurrentDirectory
                                             nil
                                             fileRemove
                                             fileRename
                                             nil
                                             newDirectory
                                             newFile)
                                  receiver:self
                                       for:fileListView)
    ]
! !
