"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

InfoBox subclass:#WarningBox
       instanceVariableNames:''
       classVariableNames:'WarnBitmap'
       poolDictionaries:''
       category:'Views-DialogBoxes'
!

WarningBox comment:'

COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

$Header: /claus/smalltalk/st2.6/libwidg/RCS/WarnBox.st,v 1.3 94/01/16 04:03:30 claus Exp $
written Summer 93 by claus
'!

!WarningBox class methodsFor:'documentation'!

documentation
"
    this class implements a pop-up box to show an information message. 
    WarningBoxes are basically InfoBoxes with a different bitmap-image.
    (also, they add a beep when popping up)

    They are created with:

        aBox := WarningBox title:'some title'.

    and shown with:

        aBox showAtPointer

    The default box shows 'yes' in its button; this can be changed with:

        aBox okText:'some string'.


    Examples:

        |aBox|

        aBox := WarningBox title:'Press ''OK'' to continue'.
        aBox okText:'OK'.
        aBox showAtPointer.

"
! !

!WarningBox methodsFor:'initialization'!

initialize
    WarnBitmap isNil ifTrue:[
        WarnBitmap := Form fromFile:'Warning.xbm' resolution:100 on:device
    ].

    super initialize.
!

initFormBitmap
    formLabel form:WarnBitmap
! !

!WarningBox methodsFor:'realization'!

show
    "added bell to wake up user"

    device beep.
    super show
! 

showAtPointer
    "added bell to wake up user"

    device beep.
    super showAtPointer
! !
